Package: qusage
Version: 2.46.0
Date: 2013-01-20
Title: qusage: Quantitative Set Analysis for Gene Expression
Authors@R: c(person("Christopher Bolen", "Developer", role = c("aut",
        "cre"), email = "cbolen1@gmail.com"), person("Gur Yaari",
        "Developer", role = "aut"), person("Juilee Thakar",
        "Developer", role = "aut"), person("Hailong Meng", 
        "Developer", role = "aut"), person("Jacob Turner", 
        "Developer", role = "aut"), person("Derek Blankenship",
        "Developer", role = "aut"), person("Steven Kleinstein",
        "Developer", role = "aut"))
Author: Christopher Bolen and Gur Yaari, with contributions from Juilee
        Thakar, Hailong Meng, Jacob Turner, Derek Blankenship, and
        Steven Kleinstein
Maintainer: Christopher Bolen <cbolen1@gmail.com>
Depends: R (>= 2.10), limma (>= 3.14), methods
Imports: utils, Biobase, nlme, emmeans, fftw
Description: This package is an implementation the Quantitative Set
        Analysis for Gene Expression (QuSAGE) method described in
        (Yaari G. et al, Nucl Acids Res, 2013). This is a novel Gene
        Set Enrichment-type test, which is designed to provide a
        faster, more accurate, and easier to understand test for gene
        expression studies. qusage accounts for inter-gene correlations
        using the Variance Inflation Factor technique proposed by Wu et
        al. (Nucleic Acids Res, 2012). In addition, rather than simply
        evaluating the deviation from a null hypothesis with a single
        number (a P value), qusage quantifies gene set activity with a
        complete probability density function (PDF). From this PDF, P
        values and confidence intervals can be easily extracted.
        Preserving the PDF also allows for post-hoc analysis (e.g.,
        pair-wise comparisons of gene set activity) while maintaining
        statistical traceability. Finally, while qusage is compatible
        with individual gene statistics from existing methods (e.g.,
        LIMMA), a Welch-based method is implemented that is shown to
        improve specificity. The QuSAGE package also includes a mixed
        effects model implementation, as described in (Turner JA et al, 
        BMC Bioinformatics, 2015), and a meta-analysis framework as 
        described in (Meng H, et al. PLoS Comput Biol. 2019).
        For questions, contact Chris Bolen (cbolen1@gmail.com) or 
        Steven Kleinstein (steven.kleinstein@yale.edu)
License: GPL (>= 2)
URL: http://clip.med.yale.edu/qusage
biocViews: GeneSetEnrichment, Microarray, RNASeq, Software,
        ImmunoOncology
git_url: https://git.bioconductor.org/packages/qusage
git_branch: RELEASE_3_23
git_last_commit: e78b0eb
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:07:23 UTC; biocbuild

#Simple function to check if a design matrix from a linear model is well conditioned.
#This is needed for the adjustment to the residuals if a random effect is present with few number of replicates
#Sometimes, depending on the model, the random effect can't be treated as a fixed effect as the design matrix of
#fixed effects becomes singular.  For longitudinal studies this is the case when subjects are nested within a single
#level of another fixed effect factor

nonsingular.check <- function(m) "matrix" %in% class(try(solve(m),silent=T))




#The qgen function.



qgen<-function(eset,design,fixed,geneSets,contrast.factor,contrast,
               random=NULL,correlation=NULL,design.sampleid=NULL){
  
  if(is.data.frame(eset)){eset = as.matrix(eset)}
  
  fixed=paste(as.character(fixed),sep="",collapse="")
  
  #If sample id variable is given we will do additional checks to make sure the expression
  #and design file match up. Otherwise it is assumed that the order of the samples in the 
  #design file is the same as the columns of eset.
  if(!is.null(design.sampleid)){
    #Removing samples in eset that do not correspond with the design and vice versa
    if(all(design[,design.sampleid] %in% colnames(eset))){
      cat("All samples present in design")
    } else{
      cat("Descrepancy of samples between eset and design. Samples not included in both are removed.")
    }
    if(all(colnames(eset) %in% design[,design.sampleid])){
      cat("\nSamples in Design and Expression Match")
    }else{
      cat("\nDescrepancy of samples between eset and design.  Samples not included in both are removed.")
    }
    #ifelse(all(design[,design.sampleid] %in% colnames(eset)),cat("All samples present in design"),cat("Descrepancy of samples between eset and design. Samples not included in both are removed."))
    #ifelse(all(colnames(eset) %in% design[,design.sampleid]),cat("Samples in Design and Expression Match"),cat("Descrepancy of samples between eset and design.  Samples not included in both are removed."))
    
    #Keep samples that are included in both eset and design
    index<-which(colnames(eset) %in% design[,design.sampleid])
    eset<-eset[,index]
    index2<-which(design[,design.sampleid] %in% colnames(eset))
    design<-design[index2,]
    
    #Order Design and expression so they are compatible for model merging
    eset<-eset[,order(colnames(eset))]
    design<-design[order(design[,design.sampleid]),]
    
  }
  
  #If samples have no sample id it is assumed they are in correct order.  We simply check 
  #if the row and column numbers match, as that is all we can do to find if there is an issue.
  
  if(is.null(design.sampleid)){
    warning("No sample identifier given. Rows in design are assumed to correspond to the columns of eset.")
    if(dim(eset)[2]!= dim(design)[1]){
      stop("Number of rows in design do not match number of samples in eset.") 
    }  
  }

  ##check that rownames of eset are valid
  if(is.null(rownames(eset))){
    stop("Rownames for eset not found")
  }
  if(length(unique(rownames(eset)))!=nrow(eset) | any(rownames(eset)=="")){
    stop("The rownames of eset are invalid. Rownames must be unique and must not contain any empty values")
  }

  #Removing rows in eset that are not in the genesets to save computational time
  geneindex<-which(rownames(eset) %in% unlist(geneSets))
  if(length(geneindex)==0){stop("Genes in geneSets do not match rownames of eset.")}
  eset<-eset[geneindex,]
  
  
  
  #Converting contrast information into actual contrast vector and checking factor name compatibility  
  contrast.factor.names<-gsub(" ","",unlist(strsplit(as.character(contrast.factor),split="*",fixed=T))[-1])
  
  contrast.factor.2<-vector("list", length(contrast.factor.names)) 
  for(i in 1:length(contrast.factor.names)){
    contrast.factor.2[[i]]<-levels(design[,contrast.factor.names[i]])
  }
  new.factor.levels<-do.call(paste,c(do.call(expand.grid,contrast.factor.2),sep=""))
  if(!all(sapply(design[,contrast.factor.names],is.factor))){
    stop("Variable included in contrast.factor is not of type 'factor'. ")
  }
  if(!all((new.factor.levels)==make.names(new.factor.levels,unique=TRUE))){
    stop("Factor level combinations specified in contrast.factor do not have valid R names.")
  } 
  contrast<-list(comparison=as.vector(do.call(makeContrasts,list(contrasts=contrast,levels=new.factor.levels))))
  
  
  
  #Determining which modeling function to use GLS or LME and what type of residuals should be calculated for qusage.
  ModelInd<-0
  ResidualMethod="Conditional"
  
  if(!is.null(random)){
    ModelInd<-1
    #checking if the random effect is "more fancy" than a random effects regarding a single repeated measure
    #aka no nested random effects. Also determining if the the number of replicates is low to take the addition residual
    #approach form the Q-gen paper
    
    val<-length(grep("/",as.character(random)[2]))
    if(val>0){ResidualMethod="Conditional"}
    if(val==0){
      rep.var<-strsplit(as.character(random)[2],"| ",fixed=T)[[1]][2]
      if(median(table(design[,rep.var]))>4){ResidualMethod="Conditional"}
      if(median(table(design[,rep.var]))<5){
        mm<-model.matrix(formula(paste(fixed,rep.var,sep="+")),data=design)
        ResidualMethod=ifelse(nonsingular.check(t(mm)%*%mm),"Adjusted","Conditional")
        if(ResidualMethod=="Conditional"){
          warning("Number of random effect replicates are low.  Adjusted Vif estimation can not be conducted due to nested factors. The conditional residuals will be used and could potentially be overly optimistic.")
        }
      }
    }    
  }
  
  #Running row by row modeling using GLS or LME depending if random effects are in the model or not
  
  #Initializing the main components needed for qusage analyis, logFc, Standard error, and d.o.f. 
  #as well as the residual matrix
  #lmm.result<-vector("list",dim(eset)[1])
  
  mean<-vector("numeric",length=dim(eset)[1])
  SD<-vector("numeric",length=dim(eset)[1])
  dof<-vector("numeric",length=dim(eset)[1])
  names(mean)<-rownames(eset)
  names(SD)<-rownames(eset)
  names(dof)<-rownames(eset)
  converge.ind<-c()
  
  residual.matrix<-matrix(, nrow = nrow(eset), ncol = ncol(eset))
  if(ResidualMethod=="Adjusted"){
    cat("Number of random effect replicates are low.  The adjusted residuals will be used for VIF estimation")
  }
  
  cat("\nRunning row by row modeling.")
  cat("\nPercent Complete:")
  percent=0.1
  #GLS
  if(ModelInd==0){

    for (i in 1:nrow(eset)){
      if((i/nrow(eset))>percent){
        cat(paste(percent*100,"%...",sep="")) 
        percent<-percent+.1
      }
      
      design$y<-eset[i,]                        
      modresult<-try(do.call(gls,
                         list(model=formula(paste("y",fixed,sep="")),data=design,
                              correlation=correlation,control=glsControl(opt='optim'))
                         ),
                     silent=T
                     )
      if("try-error" %in% class(modresult)){
        if(grepl("converg", modresult)){
          converge.ind<-c(converge.ind,i)
        }else{
          stop(modresult)
        }
      }else{
        contrast.result<-summary(contrast(emmeans(modresult,contrast.factor),contrast,by=NULL))
        mean[i]<-contrast.result$estimate
        SD[i]<-contrast.result$SE
        dof[i]<-contrast.result$df
        residual.matrix[i,]<-residuals(modresult)
      }
    }
  }
  
  
  #LME
  if(ModelInd==1){
    for (i in 1:nrow(eset)){
      if((i/nrow(eset))>percent){
        cat(paste(percent*100,"%...",sep="")) 
        percent<-percent+.1
      }
      design$y<-eset[i,]
      modresult<-try(do.call(lme,
                        list(fixed=formula(paste("y",fixed,sep="")),
                             data=design,
                             random=random,
                             correlation=correlation,
                             control=lmeControl(opt='optim')
                            )
                        ),
                      silent=T
                    )
      # modresult<-try(lme(formula(paste("y",fixed,sep="")),data=design,random=random,
      #                    correlation=correlation,control=lmeControl(opt='optim')),
      #                silent = T)
      if("try-error" %in% class(modresult)){
        if(grepl("converg", modresult)){
          converge.ind<-c(converge.ind,i)
        }else{
          stop(modresult)
        }
      }else{
      
        contrast.result<-summary(contrast(emmeans(modresult,contrast.factor),contrast,by=NULL))
        
        mean[i]<-contrast.result$estimate
        SD[i]<-contrast.result$SE
        dof[i]<-contrast.result$df
        
        if(ResidualMethod=="Conditional"){residual.matrix[i,]<-residuals(modresult)}
        if(ResidualMethod=="Adjusted"){
          residual.matrix[i,]<-residuals(lm(formula(paste("y",fixed,"+",rep.var,sep="")),data=design))
        }
      }
    }
  }
  
  
  
  rownames(residual.matrix)<-rownames(eset)
  colnames(residual.matrix)<-rep("Resid",dim(eset)[2])
  
  if(length(converge.ind)>0){
    residual.matrix<-residual.matrix[-converge.ind,]
    mean<-mean[-converge.ind]
    SD=SD[-converge.ind]
    dof=dof[-converge.ind]
    warning(paste(length(converge.ind)," gene(s) for the linear model did not converge and were removed. The first omission is found at  ",rownames(eset)[converge.ind[1]],sep=""))
  }
  
  
  results<-newQSarray(list(
    mean=mean,
    SD=SD,
    sd.alpha=setNames(rep(1, length(mean)),names(mean)),
    dof=dof,
    labels=colnames(residual.matrix)
  ))
  #final.result<-list(residual.matrix=residual.matrix,QSobject=QSobject,res.method=ResidualMethod)
  
  overlap = sapply(geneSets, function(x){ sum(x %in% rownames(eset)) })
  geneSets=geneSets[overlap>0]
  
  
  
  cat("\nAggregating gene data for gene sets.")
  results<-aggregateGeneSet(results, geneSets,n.points=2^14)
  cat("Done. \nCalculating VIF's on residual matrix.")
  results<-calcVIF(residual.matrix,results,useCAMERA=FALSE)
  cat("\nQ-Gen analysis complete.")
  results
}

## This file contains the primary code for the qusage methodology
##
## Author: Christopher Bolen
##         Gur Yaari
## Updated: 2015-09-15
## (c) 2013 Yale University. All rights reserved.

##THE BIG WRAPPER FUNCTION
## This function runs the entire qusage method on the input data, returning a single
## QSarray object containing the results of makeComparison, calcVIF, and aggregateGeneSet.
## Many of the parameters are left out of this function for simplicity, so for greater control
## each of the functions must be called separately.

qusage = function(eset,       ##a matrix of log2(expression values), with rows of features and columns of samples. OR an object of class ExpressionSet 
                  labels,            ##vector of labels representing each column of eset.
                  contrast,          ##a string describing which of the groups in 'labels' we want to compare. This is usually of the form 'trt-ctrl', where 'trt' and 'ctrl' are groups represented in 'labels'. 
                  geneSets,          ##a list of pathways to be compared. Each item in the list is a vector of names that correspond to the row names of eset.
                  pairVector=NULL,   ##A vector of factors (usually just 1,2,3,etc.) describing the sample pairings. This is often just a vector of patient IDs or something similar. If not provided, all samples are assumed to be independent.
                  var.equal=FALSE,   ##a logical variable indicating whether to treat the two variances as being equal. If TRUE then the pooled variance is used to estimate the variance otherwise the Welch approximation is used.
                  filter.genes=FALSE,##a boolean indicating whether the genes in eset should be filtered to remove genes with low mean and sd.
                  n.points=2^12      ##The number of points to sample the convolution at. Passed to aggregateGeneSet
                 ){
  ##determine the type of comparison (i.e. single, double, or more complex?)
  
  ##if double
  if(grepl("\\s*\\(.+-.+\\)\\s*-\\s*\\(.+-.+\\)\\s*",contrast, perl=TRUE)){
    
    ##split into two single comparisons
    temp = unlist(strsplit(contrast, "\\)\\s*-\\s*\\("))
    contrast1 = gsub("\\s*\\(","", x=temp[1], perl=TRUE)
    contrast2 = gsub("\\)\\s*","", x=temp[2], perl=TRUE)
    ##flip contrast2
    temp = unlist(strsplit(contrast2, "\\s*\\-\\s*"))
    contrast2 = paste0(temp[2:1], collapse="-")
    
    # run qusage for contrast1 and contrast2, 
    qs.results.1 = qusage.single(eset, labels, contrast1, geneSets, pairVector, var.equal, filter.genes, n.points)
    qs.results.2 = qusage.single(eset, labels, contrast2, geneSets, pairVector, var.equal, filter.genes, n.points)
    
    # set the number of samples to be equal (i.e. don't weight the combined pdf)
    n.s = c(qs.results.1$n.samples, qs.results.2$n.samples)
    qs.results.1$n.samples = qs.results.2$n.samples = 1
    
    qs.results.comb = combinePDFs(list(qs.results.1, qs.results.2), n.points=n.points*2)
    
    ##double the means and ranges (because we're doing addition, not average)
    qs.results.comb$path.mean = 2 * qs.results.comb$path.mean
    qs.results.comb$ranges = 2 * qs.results.comb$ranges
    
    ##remove the QSlist (so this object can be considered a normal QSarray)
    qs.results.comb$QSlist = NULL
    
    ##fix the n.samples
    qs.results.comb$n.samples = mean(n.s)
    
    
    ##add other missing bits to the qs.results
    qs.results.comb$contrast = contrast
    for(i in c("var.method","labels","pairVector","pathways","path.size")){
      if(!is.null(qs.results.1[[i]])){qs.results.comb[[i]] = qs.results.1[[i]]}
    }
    
    return(qs.results.comb)
    
  ##else, hopefully limma can handle the contrast definition
  }else{
    return(qusage.single(eset, labels, contrast, geneSets, pairVector, var.equal, filter.genes, n.points))
  }
  
}
qusage.single = function(eset,       ##a matrix of log2(expression values), with rows of features and columns of samples. OR an object of class ExpressionSet 
                         labels,            ##vector of labels representing each column of eset.
                         contrast,          ##a string describing which of the groups in 'labels' we want to compare. This is usually of the form 'trt-ctrl', where 'trt' and 'ctrl' are groups represented in 'labels'. 
                         geneSets,          ##a list of pathways to be compared. Each item in the list is a vector of names that correspond to the row names of eset.
                         pairVector=NULL,   ##A vector of factors (usually just 1,2,3,etc.) describing the sample pairings. This is often just a vector of patient IDs or something similar. If not provided, all samples are assumed to be independent.
                         var.equal=FALSE,   ##a logical variable indicating whether to treat the two variances as being equal. If TRUE then the pooled variance is used to estimate the variance otherwise the Welch approximation is used.
                         filter.genes=FALSE,##a boolean indicating whether the genes in eset should be filtered to remove genes with low mean and sd.
                         n.points=2^12      ##The number of points to sample the convolution at. Passed to aggregateGeneSet
                 ){
  cat("Calculating gene-by-gene comparisons...")
  results = makeComparison(eset, labels, contrast, pairVector=pairVector,var.equal=var.equal)
  if(filter.genes){
    results = filterGenes(results)
  }
  
  cat("Done.\nAggregating gene data for gene sets.")
  nu = floor(min(results$dof,na.rm=T))
  if(nu<5){cat("\nLow sample size detected. n.points should be increased for better accuracy.")}
  results = aggregateGeneSet(results, geneSets, silent=F, n.points=n.points)
  cat("Done.\nCalculating variance inflation factors...")
  results = calcVIF(eset, results)
  #cat("Done.\nCalculating homogeneity scores...")
  #results = calcHomogeneity(results, silent=TRUE, addVIF=FALSE)
  #cat("Done.\nCalculating correlation matrix...")  
  #results = calcPCor(eset, results)
  cat("Done.\n")
  results
}

## A wrapper function to calculate comparisons between groups in a dataset.
## 
## A note on var.equal: LIMMA's linear model function can only be run when assuming equal 
## variances. If var.equal==TRUE, then a linear model will be created on the entire dataset 
## at once. Otherwise, calcIndividualExpressions will be called for the comparison of interest,
## and means and SDs will be calculated directly.
## One benefit of using LIMMA's pooled variance calculation is that the linear models allow for more
## complicated comparisons (e.g. "(A+B)-C" or similar). This may be of interest to some users,
## but in order to do this, you must assume equal variances between all groups.
##
## One caveat regarding paired samples: LIMMA can not fit a linear model when the paired samples are
## convoluted with the groups (e.g. one set of paired (trt vs mock) samples in patients with  disease,
## combined with a set of paired samples from healthy controls). If var.equal==TRUE, these groups
## must be run separately to correctly fit the model (e.g. run disease first, then healthy controls).

makeComparison <- function(eset,       ##a matrix of log2(expression values), with rows of features and columns of samples 
                           labels,     ##vector of labels representing each column of eset.
                           contrast,   ##a string describing which of the groups in 'labels' we want to compare. This is usually of the form 'trt-ctrl', where 'trt' and 'ctrl' are groups represented in 'labels'. 
                           pairVector=NULL,  ##A vector of factors (usually just 1,2,3,etc.) describing the sample pairings. This is often just a vector of patient IDs or something similar. If not provided, all samples are assumed to be independent.
                           var.equal = FALSE, ##a logical variable indicating whether to treat the two variances as being equal. If TRUE then the pooled variance is used to estimate the variance otherwise the Welch approximation is used. 
                           bayesEstimation = TRUE, ##if true, use a bayesian framework to estimate the standard deviation (via limma's eBayes function). 
                           min.variance.factor=10^-8  ##a factor to add to the SDs to ensure that none are equal to 0. Only used if var.equal==FALSE or bayesEstimation==FALSE.
){
  
  if(is(eset, "ExpressionSet")){eset = exprs(eset)}
  ##check that input is formatted correctly
  if(length(labels)!=ncol(eset)){stop("labels length does not match columns of eset")}
  labels = as.factor(as.vector(labels))
  if(!is.character(contrast)){stop("Contrast must be a character vector of length 1.")}
  if(length(contrast)!=1){
    warning("Multiple contrasts provided. Using first contrast only.")
    contrast = contrast[1]
  }
  if(is.null(rownames(eset))){
    stop("Rownames for eset not found")
  }
  if(length(unique(rownames(eset)))!=nrow(eset) | any(rownames(eset)=="")){
    stop("The rownames of eset are invalid. Rownames must be unique and must not contain any empty values")
  }
  
  
  params = list(labels=labels, contrast = contrast)
  
  if((paired = !is.null(pairVector))){
    if(length(pairVector)!=ncol(eset)){stop("PairVector length does not match columns of eset")}
    pairVector = as.factor(as.vector(pairVector))  
    params[["pairVector"]] = pairVector
  }
  
  
  if(var.equal){
    ###################################
    ## Pooled Variance (Linear Model) method
    
    ##create design matrix
    f = "~0+labels"
    designNames = levels(labels)
    if(paired){
      f = paste(f,"+pairVector",sep="")
      designNames = c(designNames, paste("P",levels(pairVector)[-1],sep=""))
    }
    design <- model.matrix(formula(f))
    colnames(design) <- designNames
      
    ## Fit the linear model with the given deign matrix
    ## 'fit' contains info on each coefficient (i.e. column of design matrix) in the model.
    fit <- lmFit(eset, design=design)
    
    ##Contrast the coefficients against each other to get a direct comparison.
    contrast.matrix <- makeContrasts( contrasts=contrast, levels=design)
    fit2 <- contrasts.fit(fit,contrast.matrix)
    
    ##calculate number of samples use in the contrast
    n.samples = sum(labels %in% rownames(contrast.matrix)[contrast.matrix!=0])
    
    ##if using Bayes estimation, calculate the moderated t-statistics for each comparison
    if(bayesEstimation){
      fit2b <- eBayes(fit2)
      SD = (fit2b$coefficients/(fit2b$t))[,1]
      sd.alpha = SD/(fit2b$sigma*fit2b$stdev.unscaled)
      sd.alpha[is.infinite(sd.alpha)] = 1
      dof = fit2b$df.total
    }else{
      SD = sqrt((fit2$sigma*fit2b$stdev.unscaled)^2 + min.variance.factor)
      sd.alpha = SD/(fit2$sigma*fit2$stdev.unscaled)
      sd.alpha[is.infinite(sd.alpha)] = 1
      dof = fit2$df.residual
    }
    
    
    ##format 
    results = newQSarray(params, 
                      mean = fit2$coefficients[,1],
                      SD = SD,
                      sd.alpha = sd.alpha,
                      dof = dof,
                      var.method="Pooled",
                      n.samples=n.samples
                     )
  }
  if(!var.equal){
    ###################################
    ## Welch's method
    ##parse the contrast
    grps = strsplit(contrast,"-")[[1]]
    grps = sub("\\s","",grps)          ##remove whitespace
    if(length(grps)!=2){stop("Only contrasts of the form 'A-B' are allowed when var.equal is FALSE.")}
    grp.1 = labels==grps[1]  ##PostTreatment
    grp.2 = labels==grps[2]  ##Baseline
    if(sum(grp.1)==0 | sum(grp.2)==0){stop("Contrast groups do not match labels")}
    
    eset.1 = eset[,grp.1]
    eset.2 = eset[,grp.2]
    
    if(paired){
      colnames(eset.1) = pairVector[grp.1]
      colnames(eset.2) = pairVector[grp.2]
      
      #if(ncol(eset.1)!=ncol(eset.2)){
        eset.1 = eset.1[,colnames(eset.1) %in% colnames(eset.2)]
        eset.2 = eset.2[,colnames(eset.2) %in% colnames(eset.1)]
        eset.1 = eset.1[,match(colnames(eset.2),colnames(eset.1))]
      #}
    }
    params$n.samples = ncol(eset.1) + ncol(eset.2)
    
    results = newQSarray(c(params, calcIndividualExpressions(eset.2,eset.1,paired=paired,min.variance.factor=min.variance.factor)))
  }
  return(results)
}

#######Calculate individual gene differential expresseion for each gene
## This function should usually be called by "makeComparison".

calcIndividualExpressions<-function(Baseline,PostTreatment,paired=FALSE,min.variance.factor=10^-6,na.rm=TRUE){
  ###Baseline is the matix of gene expressions at baseline, row names are gene names
  ###PostTreatment is the matix of gene expressions after treatment, row names are gene names
  ###paired: logical, whether the data is paired or not
  
  ##########Some error checks
  if(length(dim(Baseline))!=2 | length(dim(PostTreatment))!=2){stop("Input Matrices need to be matrices... \n")}
  if(nrow(Baseline)!=nrow(PostTreatment)){stop("Input Matrices need to have the same number of genes \n")}
  if(sum(!(rownames(Baseline)%in%rownames(PostTreatment)))){stop("Input Matrices need to have the same list of genes. Gene names should be the row names \n")}
  if(ncol(Baseline)<2 | ncol(PostTreatment)<2 ){stop("Input Matrices need to have at least two columns \n")}

  #########Reorder PostTreatment
  PostTreatment<-PostTreatment[rownames(Baseline),]
  
#  if(!abs){
    ###########Paired
    if(paired){
      if(ncol(Baseline)!=ncol(PostTreatment)){
        stop("Input Matrices need to have the same number of columns when paired flag is on \n")
      }
      if(sum(!colnames(Baseline)%in%colnames(PostTreatment))){
        stop("Input Matrices need to have the same list of samples when paired flag is on \n")
      }
      PostTreatment = PostTreatment[,colnames(Baseline)]
      ##########First calculate the differential expression for individual genes
      Sums_Base<-rowSums(Baseline, na.rm=na.rm)
      Sums_Post<-rowSums(PostTreatment, na.rm=na.rm)
      Ns<-rowSums(!is.na(Baseline-PostTreatment), na.rm=na.rm)
      if(min(Ns)!=ncol(Baseline)){warning("Some NA's in data")}
      Sigmas_Base<-rowSums((Baseline-PostTreatment-(Sums_Base-Sums_Post)/Ns)^2,na.rm=na.rm)/(Ns-1)
      DOF<-Ns
      if(any(DOF<3, na.rm=T)){warning("Some degrees of freedom are below minimum. They have been set to 3.\nPlease refer to section 3.4 of the vignette for information on running qusage with small sample sizes.")}
      DOF[DOF<3]<-3
      Mean=(Sums_Post-Sums_Base)/Ns
      SD=sqrt(Sigmas_Base/Ns)
    }
    ###########Non Paired
    if(!paired){
      ##########First calculate the differential expression for individual genes
      Sums_Base<-rowSums(Baseline, na.rm=na.rm)
      Sums_Post<-rowSums(PostTreatment, na.rm=na.rm)
      Ns_Base<-rowSums(!is.na(Baseline), na.rm=na.rm)
      Ns_Post<-rowSums(!is.na(PostTreatment), na.rm=na.rm)
      if(min(Ns_Base)!=ncol(Baseline) | min(Ns_Post)!=ncol(PostTreatment)){warning("Some NA's in data")}
      Sigmas_Base<-rowSums((Baseline-(Sums_Base)/Ns_Base)^2,na.rm=na.rm)/(Ns_Base-1)
      Sigmas_Post<-rowSums((PostTreatment-(Sums_Post)/Ns_Post)^2,na.rm=na.rm)/(Ns_Post-1)
      ROWS<-rownames(Baseline)
      DOF<-Ni(Sigmas_Post+min.variance.factor,Sigmas_Base+min.variance.factor,Ns_Post,Ns_Base)
      #calculate degrees of freedom
      if(any(DOF<3, na.rm=T)){warning("Some degrees of freedom are below minimum. They have been set to 3.")}
      DOF[DOF<3]<-3
      Mean=(Sums_Post/Ns_Post-Sums_Base/Ns_Base)
      SD=sqrt(Sigmas_Base/Ns_Base+Sigmas_Post/Ns_Post)
    }
  sd.alpha = sqrt(SD^2+min.variance.factor)/SD
  sd.alpha[is.infinite(sd.alpha)] = 1
  
  dat = newQSarray(mean=Mean,
                SD=sqrt(SD^2+min.variance.factor),
                sd.alpha = sd.alpha,
                dof=DOF,
                var.method="Welch's"
  )
  dat
}
 
 
 #####Filter out genes with SD lower than a threshold and mean lower than another threshold
 
filterGenes<-function(QSarray,  ##A QSarray object, as generated by makeComparison 
                      Min_SD=0.01, ##threshold  for SD
                      Min_Mean=0   ##threshold  for mean
                     ){
 
 if(!is.null(QSarray$pathways)){stop("too late...aggregateGeneSet already being called")}
 
 Indexes <- abs(QSarray$mean) >= Min_Mean | QSarray$SD >= Min_SD
 
 QSarray$mean <- QSarray$mean[Indexes]
 QSarray$SD <- QSarray$SD[Indexes]
 QSarray$dof <- QSarray$dof[Indexes]
 QSarray$sd.alpha <- QSarray$sd.alpha[Indexes]
 
 return(QSarray)
}
 
##Simple function to read in a .gmt file and return a list of pathways
read.gmt = function(file){
  if(!grepl("\\.gmt$",file)[1]){stop("Pathway information must be a .gmt file")}
  geneSetDB = readLines(file)                                ##read in the gmt file as a vector of lines
  geneSetDB = strsplit(geneSetDB,"\t")                       ##convert from vector of strings to a list
  names(geneSetDB) = sapply(geneSetDB,"[",1)                 ##move the names column as the names of the list
  geneSetDB = lapply(geneSetDB, "[",-1:-2)                   ##remove name and description columns
  geneSetDB = lapply(geneSetDB, function(x){x[which(x!="")]})##remove empty strings
  return(geneSetDB)
}
 
#######Combine individual gene differential expresseion for each pathway (Neg) ~ 1 minute

aggregateGeneSet<-function(geneResults,  ##A QSarray object, as generated by makeComparison 
                           geneSets,     ##a list of pathways to be compared, each item in the list is a vector of names that correspond to the gene names from Baseline/PostTreatment
                           n.points=2^12, ##the number of points to sample the convoluted t-distribution at.
                           silent=TRUE   ##If false, print a "." every fifth pathway, as a way to keep track of progress
                          ){
  
#   NumSDs<-c(20,20,20,10,5,2,2,2,2,1,1,rep(.5,220))*30
  NumSDs<-abs(qt(10^-10,1:250))
  NumSDs[NumSDs>750] = 750
#   ,rep(abs(qt(10^-8,50)),220))  
  
  Means = geneResults$mean
  SD = geneResults$SD
  DOF=geneResults$dof
  COLS = names(Means)
  
  if(is.vector(geneSets) & !is.list(geneSets)){
    n = deparse(substitute(geneSets))
    geneSets = list(geneSets)
    names(geneSets) = n
  }
  if(is.null(names(geneSets))){names(geneSets) = 1:length(geneSets)}
  geneSets = lapply(geneSets,function(x){
    if(is.numeric(x)){
      if(any(!(x %in% 1:length(COLS)))){stop("Numeric gene set indices out of bounds")}
      return(x)
    }
    which(COLS%in%x)
  })
  
  #########First set MaxDiff to adjust to data:
  ##calculate standard deviation
  SumSigma<-sapply(names(geneSets),function(i){
      Indexes = geneSets[[i]]
      x<-sqrt(sum((SD^2*(DOF/(DOF-2)))[Indexes]))
      return(x)
  })
  
  MinDof<-sapply(names(geneSets),function(i){
      Indexes = geneSets[[i]]
      if(length(Indexes)==0){return(NA)}
      return(floor(min(DOF[Indexes])))
      })
#   MaxDiff<-pmax(NumSDs[floor(min(DOF))]*SumSigma,1)  
  MaxDiff<-pmax(NumSDs[MinDof]*SumSigma,1,na.rm=TRUE)
  MaxDiff[is.na(NumSDs[MinDof])] = abs(qt(10^-10,1000))*SumSigma
  PDFs = pathMeans = Sizes = NULL
  for(i in 1:length(geneSets)){
    if(!silent & i%%5==0){cat(".")}
    Indexes = geneSets[[i]]
    if(length(Indexes)!=0){
      Norm<-(2*MaxDiff[i]/{n.points-1}) #normalize 
      PDF<-sapply(Indexes,function(j){
          x = SD[j]
          MaxDiffInt<-MaxDiff[i]/x
          #y<-dt(seq(-MaxDiffInt,MaxDiffInt,length.out=n.points),DOF)  
          x1<-seq(-MaxDiffInt,MaxDiffInt,length.out=n.points)
          y<-dt(x1[1:(n.points/2)],DOF[j])
          y<-c(y,rev(y))
          y/sum(y)/Norm
      })
      Tmp<-multi_conv(PDF)
      Tmp = Tmp*(n.points-1)/MaxDiff[i]/2
    }else{
      warning(paste("Gene set: (index ",i, ") has 0 overlap with eset.",sep=""))
      Tmp = rep(NA, n.points)
    }
    PDFs = cbind(PDFs,Tmp)
    pathMeans = c(pathMeans, mean(Means[Indexes]))
    Sizes = c(Sizes, length(Indexes))
  }
  
  colnames(PDFs) = names(pathMeans) = names(Sizes) = names(geneSets)
  ##add the new data to the existing QSarray object
  geneResults$pathways = geneSets
  geneResults$path.mean = pathMeans
  geneResults$path.size = Sizes
  geneResults$ranges = MaxDiff/Sizes
  geneResults$n.points=n.points
  geneResults$path.PDF = PDFs
  return(geneResults)
}

###A function to calculate the Variance Inflation Factor (VIF) for each of the gene sets input in geneSets
## This function depends on which method you used to calculate the variance originally. 
## If you assumed pooled variance, then the variance will be calculated using LIMMA's
## "interGeneCorrelation" method (see Wu and Smyth, Nucleic Acids Res. 2012). Otherwise, the method
## will calculate the VIF separately for each group and return the average of each group's vif.

calcVIF = function(eset,         ##a matrix of log2(expression values). This must be the same dataset that was used to create geneResults
                   geneResults,  ##A QSarray object, as generated by either makeComparison or aggregateGeneSet
                   useCAMERA = geneResults$var.method=="Pooled",  ##The method used to calculate variance. See the description for more details. By default, it uses the parameter stored in the geneResults
#                    geneSets=NULL, ##a list of pathways calculate the vif for, each item in the list is a vector of names that correspond to the gene names from Baseline/PostTreatment
                   useAllData = TRUE ##Boolean parameter determining whether to use all data in eset to calculated the VIF, or whether to only use data from the groups being contrasted. Only used if useCAMERA==FALSE
                  ){
  
#   if(is.null(geneSets)){
    if(is.null(geneResults$pathways)){stop("Pathway Information not found. Please provide a list of gene sets.")}
    geneSets = geneResults$pathways
#   }else{
#     if(is.vector(geneSets) & !is.list(geneSets)){
#       n = deparse(substitute(geneSets))
#       geneSets = list(n = geneSets)
#       names(geneSets) = n
#     } 
#     geneSets = lapply(geneSets,function(x){which(names(geneResults$mean)%in%x)})
#     geneResults$pathways = geneSets
#   }
    
  if(is(eset, "ExpressionSet")){eset = exprs(eset)}
  if(!("QSarray" %in% class(geneResults))){stop("geneResults must be a QSarray object, as created by makeComparison")}
    
  ##create design matrix
  if(useCAMERA){
    labels = geneResults$labels
    paired=F
    if(!is.null(geneResults$pairVector)){paired=T; pairVector = geneResults$pairVector}
    
    f = "~0+labels"
    designNames = levels(labels)
    if(paired){
      f = paste(f,"+pairVector",sep="")
      designNames = c(designNames, paste("P",levels(pairVector)[-1],sep=""))
    }
    design <- model.matrix(formula(f))
    colnames(design) <- designNames
  }
  
  ##run VIF calculation on each gene set
  vif = sapply(names(geneSets),function(i){
    GNames<-names(geneResults$mean)[geneSets[[i]]]
    gs.i = which(rownames(eset)%in%GNames)
#     gs.i = geneSets[[i]]
    if(length(gs.i)<2){warning("GeneSet '",i,"' contains one or zero overlapping genes. NAs produced.");return(NA)}    
    if(useCAMERA){
      return(interGeneCorrelation(eset[gs.i,],design)$vif)
    }
    else{
#       grps = sub("\\s","",strsplit(geneResults$contrast,"-")[[1]])  ##only calc vif for the groups that were compared
#       vif.grp = sapply(split(1:ncol(eset),geneResults$labels)[grps], function(j){
#         covar.mat = cov(t(eset[gs.i,j]))
#         return(sum(covar.mat)/sum(diag(covar.mat)))
#       })
#       return(mean(vif.grp,na.rm=T))
      
      ##pooled covariance matrix
      grps = split(1:ncol(eset),geneResults$labels)
      if(!useAllData){
        toInclude = sub("\\s","",strsplit(geneResults$contrast,"-")[[1]])  ##only calc vif for the groups that were compared
        grps = grps[toInclude]
      }
      covar.mat = cov(t(eset[gs.i,grps[[1]]])) * (length(grps[[1]])-1)
      if(length(grps)>1){
        for(i in 2:length(grps)){
          covar.mat = covar.mat + ( cov(t(eset[gs.i,grps[[i]]])) * (length(grps[[i]])-1) )
        } 
      }
      covar.mat = covar.mat / (ncol(eset) - length(grps))
      
      ##multiply matrix by the sd.alpha vectors
      if(!is.null(geneResults$sd.alpha)){
        a = geneResults$sd.alpha[rownames(eset)[gs.i]]
        covar.mat = t(covar.mat*a)*a
      }
      
      vif = sum(covar.mat)/sum(diag(covar.mat))
      return(vif)
    }
  })
  geneResults$vif = vif
  if(!is.null(geneResults$path.PDF)){ ##if defined, rescale the pdf with the new vif values
    geneResults$path.PDF = t(t(geneResults$path.PDF) / pdfScaleFactor(geneResults))
  }
  return(geneResults)
}


##!!----deprecated. Use pdf.pVal instead
oneWay.pVal <- function(QSarray, alternative=c("two.sided","less","greater"),
                        direction=FALSE, addVIF=!is.null(QSarray$vif), selfContained=TRUE){#, absolute=FALSE){
  warning("Hey -- I changed the name. 'pdf.pVal' is less confusing. Use that.")
  return(pdf.pVal(QSarray, alternative, direction,addVIF,selfContained))#,absolute))
}
## function for calculating a p-value for each pathway convolution as output by aggregateGeneSet.
pdf.pVal <- function(QSarray,                          ##The output of qusage (or aggregateGeneSet)
                     alternative=c("two.sided","less","greater"), ## If alternative = "two.sided", this tests whether the mean of the distribution is equal to 0. If alternative = "greater", the alternative is that the mean is greater than than 0.
                     direction=FALSE,                  ##If true (and alternative="two.sided"), p-values will be returned as eiter positive or negative if the pathway is greater or less than 0, respectively.
                     addVIF=!is.null(QSarray$vif),     ##Whether to include the VIF in the calculation of the p-values. By default, if the VIF has been calculated, it will be used
                     selfContained=TRUE                ##If false, rather than comparing to 0, it will compare the pathway mean to the mean of all genes not in the pathway.
                     #absolute=FALSE                    ##If true, computes a P value for the "absolute test".
){ 
  if(is.null(QSarray$path.PDF)){stop("convolution results not found.")}
  p = sapply(1:ncol(QSarray$path.PDF), function(i){
    if(!is.null(QSarray$path.size) && QSarray$path.size[i]==0){return(NA)}
    
    #calculate null hypothesis
    if(!selfContained){
      if(!is.null(QSarray$QSlist) && is.null(QSarray$mean)){
        null.hyp = sapply(QSarray$QSlist, function(q){
          path = q$pathways[[i]]
          mean(q$mean[-path])
        })
        null.hyp = sum(null.hyp * QSarray$n.sample)/sum(QSarray$n.samples)
      }else{
        path = QSarray$pathways[[i]]
        null.hyp = mean(QSarray$mean[-path])
      }
      
    }else{
      null.hyp=0
#       if(!absolute){null.hyp=0}
#       else{
#         path = QSarray$pathways[[i]]
#         null.hyp=mean(getExAbs(QSarray$dof[path])*QSarray$SD[path])
#       }    
    }
    ##find location of null hypothesis and sum pdf
    x = getXcoords(QSarray,i,addVIF=addVIF)#,absolute=absolute)
    PDF_NORM<-QSarray$path.PDF[,i]/sum(QSarray$path.PDF[,i])
#     sum(QSarray$path.PDF[1:findInterval(0,x),i]) / sum(QSarray$path.PDF[,i])
    INDEX<-findInterval(null.hyp,x)
    if(INDEX==0){return(0)}; if(INDEX==length(x)){return(1)}
    sum(PDF_NORM[1:INDEX])+((null.hyp-x[INDEX])/(x[INDEX+1]-x[INDEX]))*PDF_NORM[INDEX+1]
  })
  
  ##fix p-values based on test side
  dir = match.arg(alternative)
  if(dir=="two.sided"){
    p[which(p>0.5)] = -1+p[which(p>0.5)]   ### turn it into a two-tailed p
    p = ifelse(rep(direction,length(p)),p*2,abs(p*2))
    return(p)
  }
  if(dir=="less"){return(1-p)}
  return(p)
}


##!!----deprecated. Use twoCurve.pVal instead
twoWay.pVal <- function(grp1, grp2, path.index1 = 1:numPathways(grp1), path.index2 = 1:numPathways(grp2), 
                        alternative=c("two.sided","less","greater"), direction=FALSE, 
                        addVIF=!(is.null(grp1$vif) | is.null(grp2$vif))){
  warning("Hey -- I changed the name. 'twoCurve.pVal' is less confusing. Use that.")
  return(twoCurve.pVal(grp1, grp2, path.index1, path.index2, alternative, direction,addVIF))
}

## A method to compare the pathway convolutions in two QSarray objects. 
## If alternative = "two.sided", this tests whether the mean of the two distributions are equal.
## If alternative = "greater", the alternative is that grp1 is greater than group2
twoCurve.pVal<-function(grp1, grp2,
                        path.index1 = 1:numPathways(grp1),
                        path.index2 = 1:numPathways(grp2), 
                        alternative=c("two.sided","less","greater"),
                        direction=FALSE, 
                        addVIF=!(is.null(grp1$vif) | is.null(grp2$vif))
                     ){
  ##if the names of the pathways don't match, 
#   if(ncol(grp1$path.PDF)!=ncol(grp2$path.PDF) | all(colnames(grp1$path.PDF) != colnames(grp2$path.PDF))){
#     stop("Pathways in grp1 do not match pathways in grp2")
#   }
  if(length(path.index1)!=length(path.index2)){
    stop("Number of pathways in grp1 do not match number of pathways in grp2")
  }
#     if(sum(names(grp1$path.mean[path.index1])!=names(grp2$path.mean[path.index2]))){
#         warning("Some of the comparisons are made between different pathways")
#   }
  alternative=match.arg(alternative)
  x1 = sapply(path.index1,function(i){getXcoords(grp1,i,addVIF=addVIF)})
  x2 = sapply(path.index2,function(i){getXcoords(grp2,i,addVIF=addVIF)})
  Length1 = grp1$n.points
  Length2 = grp2$n.points
  Min<-apply(rbind(x1,x2),2,min)
  Max<-apply(rbind(x1,x2),2,max)
  p = sapply(1:length(path.index1), function(i){
    if(is.na(Max[i])){return(NA)}
    PDF1<-approx( x1[,i], grp1$path.PDF[,path.index1[i]],seq(Min[i],Max[i],length.out=Length1+Length2),rule=2)$y
    PDF2<-approx( x2[,i], grp2$path.PDF[,path.index2[i]],seq(Min[i],Max[i],length.out=Length1+Length2),rule=2)$y
    return(compareTwoDistsFaster(PDF1,PDF2, alternative=alternative))
  })
  ifelse(rep(direction,length(p)), p, abs(p))
}

## Calculates the x-coordinates for the PDF of a given pathway.
## path.index can either be an integer between 1 and length(path.means), or the name of the pathway.
## addVIF is a boolean determining whether information on the VIF should be used in the calculation
## of the x-coordinates.
getXcoords = function(QSarray,path.index=1, addVIF=!is.null(QSarray$vif)){ #,absolute=FALSE){
  if(length(path.index)>1){stop("path.index must be of length 1")}
  if(is.null(QSarray$vif) && addVIF){stop("vif is undefined for QSarray object. addVIF can not be set to true.")}
  
  sif = ifelse(addVIF,sqrt(QSarray$vif[path.index]),1)
  if(is.na(sif)){sif=1}
    
#   if(!absolute){
  seq(-1,1,length.out=QSarray$n.points)* QSarray$ranges[path.index]* sif + QSarray$path.mean[path.index]
#   }
#    else {
#    ###First calculate the new mean of the pathway based on the absolute values of the means
#    MeanAbs<-mean(abs(QSarray$mean[QSarray$pathways[[path.index]]]))
#    seq(-1,1,length.out=QSarray$n.points)* QSarray$ranges[path.index]* sif / QSarray$path.size[path.index] + MeanAbs
#   }
}


##calculate a scaling factor to multiply the PDF by (so that it actually integrates to 1)
##this is primarily used for plotting of the PDF.
pdfScaleFactor = function(QSarray, addVIF=!is.null(QSarray$vif)){
  if(is.null(QSarray$vif) && addVIF){stop("vif is undefined for QSarray object. addVIF can not be set to true.")}
  sif = sapply(1:numPathways(QSarray),function(i){ifelse(addVIF,sqrt(QSarray$vif[i]),1)})
  sif[is.na(sif)] = 1
  pdfSum = colSums(QSarray$path.PDF)
  
  ##get the pdf range
  ranges = QSarray$ranges * 2
  
  ##the scale factor is essentially the distance between points in the x coordinates times the (current) sum of the pdf
  scaleFactor = (ranges*sif) / (QSarray$n.points-1) * pdfSum
  scaleFactor
}


## Computes the 95% CI for a pdf
calcBayesCI <- function(QSarray,low=0.025,up=1-low,addVIF=!is.null(QSarray$vif)){
  cis = sapply(1:ncol(QSarray$path.PDF), function(i){
    if( (!is.null(QSarray$pathways) && length(QSarray$pathways[[i]])==0 ) ||
        any(is.na(QSarray$path.PDF[,i]))){return(c(NA,NA))}
    x = getXcoords(QSarray,i,addVIF=addVIF)
    cdf = cumsum(QSarray$path.PDF[,i])
    cdf = cdf/cdf[length(cdf)]
    INDEX_LOW<-findInterval(low,cdf)
    INDEX_UP<-findInterval(up,cdf)
    return( c(  x[INDEX_LOW]+ ((low-cdf[INDEX_LOW])/(cdf[INDEX_LOW+1]-cdf[INDEX_LOW]))*(x[INDEX_LOW+1]-x[INDEX_LOW]) ,
                x[INDEX_UP] + ((up-cdf[INDEX_UP])/(cdf[INDEX_UP+1]-cdf[INDEX_UP]))*(x[INDEX_UP+1]-x[INDEX_UP])
            ) )
#     return( c(x[findInterval(low,cdf)-1] , x[findInterval(up,cdf)]) )
  })
  colnames(cis) = colnames(QSarray$path.PDF)
  rownames(cis) = c("low","up")
  return(cis)
}

## Compute p-value of two distributions not centered at zero
compareTwoDistsFaster <-function(dens1=runif(256*8,0,1), dens2=runif(256*8,0,1),alternative="two.sided"){
  if(length(dens1)>1 & length(dens2)>1 ){
    dens1<-dens1/sum(dens1)
    dens2<-dens2/sum(dens2)
    cum2 <- cumsum(dens2)-dens2/2
    tmp<- sum(sapply(1:length(dens1),function(i)return(dens1[i]*cum2[i])))
    if(alternative=="two.sided"){
      if(tmp>0.5)tmp<-tmp-1
      return( tmp*2 )
    }
    if(alternative=="less"){return(1-tmp)}
    return(tmp)
  }
  else {
    return(NA)
  }
}

################################FFT method for convolution

multi_conv<-function(x){
  x_fft<-apply(x,2,function(x)fft(x, inverse = FALSE))
  # x_fft<-apply(x,2,function(x)fftw::FFT(x, inverse = FALSE))
  M<-max(Mod(x_fft))
  x_fft<-x_fft/M
  Prod_fft<-apply(x_fft,1,prod)
  p1<-Re(fft(Prod_fft,inverse=TRUE))
  # p1<-Re(fftw::FFT(Prod_fft,inverse=TRUE))
  N<-nrow(x)
  #     if(ncol(x)%%2==0)p1<-c(p1[(N/2+1):N],p1[1:(N/2)])
  Mp1<-which.max(p1)
  Delta<-N/2-Mp1
  if(Delta>0){
    p1<-c(p1[(N-Delta):N],p1[1:(N-Delta-1)])
  }
  if(Delta<0){
    p1<-c(p1[(1-Delta):N],p1[1:(1-Delta-1)])
  }    
  p2 = abs(p1)
  return(p2/sum(p2))
}

###A helper function to calculate degrees of freedom
Ni<-function(SigmaOld,SigmaYoung,NOld,NYoung){
 # (SigmaYoung^2/NYoung+SigmaOld^2/NOld)^2/(((SigmaYoung^4/(NYoung^2*(NYoung-1))))+((SigmaOld^4/(NOld^2*(NOld-1)))))
  (SigmaYoung/NYoung+SigmaOld/NOld)^2/(((SigmaYoung^2/(NYoung^2*(NYoung-1))))+((SigmaOld^2/(NOld^2*(NOld-1)))))
}


#############################################################################################
######################### Absolute Test / Homogeneity Score functions #######################


absoluteTest = function(eset, QSarray, p.adjust.method="fdr", silent=F){
  cat("Calculating Individual Gene Pvals.")
  gene.pvals = absoluteTest.genePvals(QSarray, compareTo="z",silent=silent)
  cat("Done.\nCalculating VIF...")
  corMats = calcPCor(eset, QSarray)
  cat("Done.\n")
  
  ##aggregate p-values 
  PVALS<-(sapply(1:length(gene.pvals),function(i){
    Chi2<-(-2)*sum(log(abs(gene.pvals[[i]])))
    k = length(gene.pvals[[i]])
    corMat = corMats[[i]]
    COR = 4*k+sum(ifelse(corMat > 0,corMat*(3.25 + 0.75*corMat),corMat*(3.27 + 0.71*corMat) ))
    f = 8*(k)^2/COR
    c = COR/4/k       
    Chi2<-Chi2/c
    P<-1-pchisq(Chi2,f)
  }))
  
  return(newQSarray(QSarray, absolute.p = PVALS))
}

homogeneityScore = function(QSarray){
  cat("Calculating Individual Gene Pvals.")
  gene.pvals = absoluteTest.genePvals(QSarray, compareTo="p")
  cat("Done.\n")
  
  ##aggregate p-values 
  PVALS<-(sapply(1:length(gene.pvals),function(i){
    Chi2<-(-2)*sum(log(abs(gene.pvals[[i]])))
    k = length(gene.pvals[[i]])
    P<-1-pchisq(Chi2,2*k)
  }))
  
  homogeneity = 1/(1-log10(PVALS))
  
  return(newQSarray(QSarray, homogeneity = homogeneity))
}

###A function to calculate the P values for each gene as compared with either 
## 0, the gene set mean, or the full PDF of the gene set. 


absoluteTest.genePvals<-function(QSarray,  ##A QSarray object, as generated by aggregateGeneSet and possibly modified by calcVIF
                                 path.index=1:numPathways(QSarray), ##The pathways to calculate the pVals for.
                                 silent=TRUE,   ##If false, print a "." every fifth pathway, as a way to keep track of progress  
                                 FastApproximated=TRUE, ##fast mode which uses normal approximations for the PDF's
                                 addVIF=!is.null(QSarray$vif), ##Whether to include the VIF in the calculation of the p-values. By default, if the VIF has been calculated, it will be used
                                 NPoints=QSarray$n.points/8, ##,
                                 compareTo=c("zero","mean","pdf") ##the null hypothesis that each gene set is tested against.
                                ){
  ##check path.index
  if(is.character(path.index)){
    path.index = match(path.index, names(QSarray$pathways))
  }
  
  NumSDs<-c(1000,abs(qt(10^-8,2:250)))  
  if(is.null(QSarray$pathways)){stop("Pathway Information not found. Please run aggregateGeneSet first.")}
  geneSets = QSarray$pathways
  if(addVIF==TRUE){addVIF=!is.null(QSarray$vif)}
  Means = QSarray$mean
  SD = QSarray$SD
  DOF=QSarray$dof
  Ps = list()
  if (FastApproximated) {
    SDPath = apply(calcBayesCI(QSarray,low=0.5,up=0.8413448)[,path.index,drop=F],2,function(x)x[2]-x[1])
    if(!addVIF)SDPath = SDPath / sqrt(QSarray$vif[path.index])
  }
  
  compareTo = match.arg(compareTo)
  if(compareTo=="pdf"){
    #NPoints=QSarray$n.points/8
    for(i in path.index){
      XPath = getXcoords(QSarray,i,addVIF=addVIF)
      if(!silent & i%%5==0){cat(".")}
      Indexes = geneSets[[i]]
      if(!FastApproximated){
        XGene <- seq(-1,1,length.out=NPoints) * NumSDs[floor(min(DOF[Indexes]))] 
        Min<-min(c(XGene[1]+ Means[Indexes],XPath[1]))
        Max<-max(c(XGene[NPoints]+ Means[Indexes],XPath[QSarray$n.points]))
        X_Sample<-seq(Min,Max,length.out=NPoints)
        PDFPath<-approx( XPath, QSarray$path.PDF[,i],X_Sample,rule=2)$y
        if(length(Indexes)!=0){
          PS<-NULL
          for(j in Indexes){          
            y<-dt(XGene[1:(NPoints/2)]/ SD[j],DOF[j])
            PDFGene<-c(y,rev(y))
            PDFGene<-approx( XGene+ Means[j], PDFGene,X_Sample,rule=2)$y
            PS<-c(PS,compareTwoDistsFaster(PDFGene,PDFPath, alternative="two.sided"))                    
          }
          Ps<-c(Ps,list(PS))
        }
      }
      else{
        if(length(Indexes)!=0){
          PS<-NULL
          for(j in Indexes){  
            TMP<-pnorm( ( Means[j] - QSarray$path.mean[i]  ) / sqrt( SDPath[i]^2 + (DOF[j])/(DOF[j]-2)*SD[j]^2) )
            if(TMP>0.5) TMP <- TMP - 1
            TMP <- TMP*2
            PS<-c(PS,TMP)
          }
          Ps<-c(Ps,list(PS))
        }
      }
    }
  }
  else{
    for(i in path.index){
      if(!silent & i%%5==0){cat(".")}
      Indexes = geneSets[[i]]
      if(length(Indexes)!=0){
        PS<-NULL
        for(j in Indexes){
          SUBSTRACT=0
          if(compareTo=="mean")SUBSTRACT=QSarray$path.mean[i]
          p<-pt((Means[j]-SUBSTRACT)/SD[j],DOF[j])
          p[which(p>0.5)] = -1+p[which(p>0.5)]   ### turn it into a two-tailed p
          p = p*2
          PS<-c(PS,p)                    
        }
        Ps<-c(Ps,list(PS))
      }
    }
  }
  names(Ps) = names(geneSets)[i]
  return(Ps)
}

###A function to calculate the "homogeneity" P value FAST


absoluteTest.genePvalsFAST<-function(QSarray,  ##A QSarray object, as generated by aggregateGeneSet and possibly modified by calcVIF
                              CompareWithZero=TRUE ###Logical, if TRUE compares with mean of zero, else with mean of pathway
){
  if(is.null(QSarray$pathways)){stop("Pathway Information not found. Please provide a list of gene sets.")}
  geneSets = QSarray$pathways
  Means = QSarray$mean
  SD = QSarray$SD
  DOF=QSarray$dof
  Ps = list()
  for(i in 1:length(geneSets)){
    Indexes = geneSets[[i]]
    if(length(Indexes)!=0){
      PS<-NULL
      
      PS<-sapply(Indexes,function(j){
        SUBSTRACT=0
        if(!CompareWithZero)SUBSTRACT=QSarray$path.mean[i]
        p<-pt((Means[j]-SUBSTRACT)/SD[j],DOF[j])
        p[which(p>0.5)] = -1+p[which(p>0.5)]   ### turn it into a two-tailed p
        p = p*2
        return(p)
      })
      Ps[[i]]<-PS
    }
  }
  names(Ps) = names(geneSets)
  return(Ps)
}


###A function to calculate the Variance Inflation Factor (VIF) for each of the gene sets input in geneSets
## This function depends on which method you used to calculate the variance originally. 
## If you assumed pooled variance, then the variance will be calculated using LIMMA's
## "interGeneCorrelation" method (see Wu and Smyth, Nucleic Acids Res. 2012). Otherwise, the method
## will calculate the VIF separately for each group and return the average of each group's vif.

calcPCor = function(eset,         ##a matrix of log2(expression values). This must be the same dataset that was used to create geneResults
                    geneResults,  ##A QSarray object, as generated by either makeComparison or aggregateGeneSet
                    useCAMERA = geneResults$var.method=="Pooled",  ##The method used to calculate variance. See the description for more details. By default, it uses the parameter stored in the geneResults
#                    geneSets=NULL, ##a list of pathways calculate the vif for, each item in the list is a vector of names that correspond to the gene names from Baseline/PostTreatment
                    useAllData = TRUE ##Boolean parameter determining whether to use all data in eset to calculated the VIF, or whether to only use data from the groups being contrasted. Only used if useCAMERA==FALSE
){
  if(is.null(geneResults$pathways)){stop("Pathway Information not found. Please provide a list of gene sets.")}
  geneSets = geneResults$pathways  
  if(!("QSarray" %in% class(geneResults))){stop("geneResults must be a QSarray object, as created by makeComparison")}
  
  ##create design matrix
  if(useCAMERA){
    labels = geneResults$labels
    paired=F
    if(!is.null(geneResults$pairVector)){paired=T; pairVector = geneResults$pairVector}
    
    f = "~0+labels"
    designNames = levels(labels)
    if(paired){
      f = paste(f,"+pairVector",sep="")
      designNames = c(designNames, paste("P",levels(pairVector)[-1],sep=""))
    }
    design <- model.matrix(formula(f))
    colnames(design) <- designNames
  }
  
  Cor = sapply(names(geneSets),function(i){
    GNames<-names(geneResults$mean)[geneSets[[i]]]
    gs.i = which(rownames(eset)%in%GNames)
    #     gs.i = geneSets[[i]]
    if(length(gs.i)<2){warning("GeneSet '",i,"' contains one or zero overlapping genes. NAs produced.");return(NA)}    
    if(useCAMERA){
      return(interGeneCorrelation(eset[gs.i,],design)$vif)
    }
    else{
      ##pooled covariance matrix
      grps = split(1:ncol(eset),geneResults$labels)
      if(!useAllData){
        toInclude = sub("\\s","",strsplit(geneResults$contrast,"-")[[1]])  ##only calc vif for the groups that were compared
        grps = grps[toInclude]
      }
      covar.mat = cov(t(eset[gs.i,grps[[1]]])) * (length(grps[[1]])-1)
      if(length(grps)>1){
        for(i in 2:length(grps)){
          covar.mat = covar.mat + ( cov(t(eset[gs.i,grps[[i]]])) * (length(grps[[i]])-1) )
        } 
      }
      covar.mat = covar.mat / (ncol(eset) - length(grps))
      
      ##multiply matrix by the sd.alpha vectors
      if(!is.null(geneResults$sd.alpha)){
        a = geneResults$sd.alpha[rownames(eset)[gs.i]]
        covar.mat = t(covar.mat*a)*a
      }
      Cor = (covar.mat)
      Cor = sapply(1:ncol(Cor),function(i)Cor[i,]/sqrt(covar.mat[i,i]))
      Cor = sapply(1:ncol(Cor),function(i)Cor[,i]/sqrt(covar.mat[i,i]))
      Cor[!is.finite(Cor)] = 0
      return(Cor)
    }
  })
  
  return(Cor)
}



approximatedNu<-c(7.2144478,4.7860183,3.4886415,2.7484892,2.2968314,2.0029888,1.8005629,1.6541477,1.5438879,1.4580784,1.4085490,1.3518729,1.3046939,1.2648251,1.2306984,1.2011619,1.1753513,1.1526056,1.1324114,1.1143633,
                  1.1024454,1.0877347,1.0743740,1.0621861,1.0510235,1.0407625,1.0312984,1.0225419,1.0144168,1.0068572,0.9999555,0.9933631,0.9871863,0.9813873,0.9759323,0.9707917,0.9659392,0.9613512,0.9570067,0.9528868,
                  0.9489987,0.9452788,0.9417375,0.9383622,0.9351415,0.9320650,0.9291232,0.9263076,0.9236102,0.9210236,0.9185485,0.9161642,0.9138723,0.9116673,0.9095447,0.9074997,0.9055282,0.9036264,0.9017905,0.9000173,
                  0.8983066,0.8966494,0.8950460,0.8934938,0.8919904,0.8905335,0.8891210,0.8877509,0.8864214,0.8851306,0.8838784,0.8826602,0.8814760,0.8803245,0.8792042,0.8781140,0.8770525,0.8760188,0.8750118,0.8740303,
                  0.8730745,0.8721414,0.8712313,0.8703431,0.8694763,0.8686299,0.8678033,0.8669957,0.8662066,0.8654354,0.8646819,0.8579745,0.8524911,0.8479247,0.8440630,0.8407547,0.8378886,0.8353818,0.8331706,0.8312056,
                  0.8294480,0.8278664,0.8264358,0.8251355,0.8239485,0.8228606,0.8218598,0.8209362,0.8200810,0.8192871,0.8185480,0.8178582,0.8172130,0.8166081,0.8160400,0.8155053,0.8150013,0.8145252,0.8140749,0.8136484,
                  0.8132437,0.8128593,0.8124937,0.8121455,0.8118135,0.8114966,0.8111938,0.8109042,0.8106269,0.8103612,0.8101063,0.8098617,0.8096266,0.8094006,0.8091831,0.8089737,0.8087719,0.8085773,0.8083896,0.8082083,
                  0.8080332,0.8078639,0.8077002,0.8075418,0.8073884,0.8072398,0.8070957,0.8069561,0.8068206,0.8066891,0.8065614,0.8064373,0.8063168,0.8061996,0.8060856,0.8059747,0.8058667,0.8057616,0.8056593,0.8055595,
                  0.8054623,0.8053675,0.8052751,0.8051849,0.8050969,0.8050110,0.8049271,0.8048452,0.8047651,0.8046869,0.8046104,0.8045356,0.8044625,0.8043909,0.8043209,0.8042524,0.8041854,0.8041197,0.8040554,0.8039924,
                  0.8039306,0.8033756,0.8029140,0.8025239,0.8021900,0.8019008,0.8016481,0.8014253,0.8012274,0.8010504,0.8008913,0.8007473,0.8006165,0.8004972,0.8003878,0.8002872,0.8001944,0.8001085,0.8000287,0.7999545,
                  0.7998852,0.7998204,0.7997597,0.7997027,0.7996490,0.7995984,0.7995507,0.7995055,0.7994627,0.7994221,0.7993835,0.7993468,0.7993119,0.7992786,0.7992468,0.7992165,0.7991874,0.7991596,0.7991330,0.7991074,
                  0.7990829,0.7990593,0.7990367,0.7990149,0.7989939,0.7989737,0.7989542,0.7989354,0.7989172,0.7988996,0.7988827,0.7988663,0.7988504,0.7988350,0.7988201,0.7988057,0.7987917,0.7987781,0.7987650,0.7987522,
                  0.7987397,0.7987277,0.7987159,0.7987045,0.7986934,0.7986826,0.7986720,0.7986618,0.7986518,0.7986421,0.7986326,0.7986233,0.7986143,0.7986055,0.7985969,0.7985885,0.7985803,0.7985722,0.7985644,0.7985568,
                  0.7985493,0.7985419,0.7985348,0.7985278,0.7985209,0.7985142,0.7985076,0.7985012,0.7984949,0.7984887,0.7984826)

getExAbs<-function(Nu){
  approx(c(seq(1,10,0.1),seq(11,100,1),seq(110,1000,10)),approximatedNu,Nu)$y
}

###################################################
## This file contains a technical description of the "QSarray" class, 
## and S4 methods for working with QSarray objects.
##
## Author: Christopher Bolen
## Updated: 2013-03-15
## ? 2013 Yale University. All rights reserved.

###The QSarray object contains data generated when running the Q-Sage method.
## It is primarily generated by the functions "q.sage","makeComparisons", or "calcIndividualExpressions"
## This method is designed to create a new QSarray object (if one of the above functions is not used).
## You can input a list object containing the fields of the new QSarray object, input these fields
## individually, or do a combination of both.

###Possible Fields:
## mean - The average fold change of each gene, calculated using makeComparisons or calcIndividualExpressions.
## SD - The standard deviation around the fold change.
## dof - Degrees of freedom for each gene.
## var.method -- one of c("Welch's","Pooled"), indicating the method used to calculate the variance
## sd.alpha - The factor each sd is multiplied by (either due to the min.variance.factor parameter in makeComparison or because of the Bayesian shrinkage of the SDs). This is used when calculating the VIF in order to correct for genes with 0 (or very small) variance.
## labels - The labels as input in makeComparisons, describing the group structure of the data.
## pairVector - A vector indicating which samples should be treated as pairs.
## contrast - A string describing which of the two groups in labels was compared.
##Pathway stuff:
## pathways - the list of genes in each gene set.
## path.mean - vector describing the mean fold change for each of the pathways provided to AggregateGeneSet
## path.PDF - Matrix describing the probability distributions for each of the pathways provided to AggregateGeneSet, where each column is a different gene set, and each row is a different point where this set was sampled. See the details section for how to find the x-coordinates for each PDF.
## path.size - The number of features in each pathway that mapped to the input data.
## ranges - the (uncorrected) range that all PDFs were calculated over. Together with n.points  and (optionally) vif, this is used to find the x-coordinates for the PDF.
## n.points - The number of points that the PDF was calculated at. This is equal to the number of rows in path.PDF
## vif - the Variance Inflation Factor for each pathway, as calculated by calcVIF
## absolute.p - p-values for the absolute gene set test, as generated by absoluteTest()
## homogeneity - a measurement of the consistency of the genes in each gene set.



setClass("QSarray", representation("list"))

##a constructor for the object
newQSarray = function(obj=NULL,
                      ...
                      ){
  output = list()
    
  if(!is.null(obj) & is.list(obj)){
    for(n in names(obj)){
      if(!is.null(output[[n]])){
        warning("Parameter '",n,"' defined more than once. Overwriting parameter provided in obj")
      }else{
        output[[n]] = obj[[n]]
      }
    }
  }
  if(length(list(...))>0){
    obj = list(...)
    for(n in names(obj)){
      if(!is.null(output[[n]])){
        warning("Parameter '",n,"' defined more than once. Overwriting parameter provided in obj")
      }
      output[[n]] = obj[[n]]
    }    
  }
  
  ##check that requried fields are there, and that all the fields are allowed.
  reqField = c()
  optField = c("mean","SD","dof","sd.alpha","var.method","labels","contrast","pairVector",
               "pathways","path.mean","path.PDF","path.size","ranges","n.points","vif",
               "QSlist","n.samples","absolute.p","homogeneity")
#   if(!any(reqField %in% names(output))){
#     stop("Missing required fields: ",paste(reqField[!(reqField %in% names(output))],collapse=", "))
#   }
  if(!all(names(output) %in% c(reqField,optField))){
    stop("Field not used: ",paste(names(output)[!(names(output) %in% c(reqField,optField))],collapse=", "))
  }
  
  return(new("QSarray", output))
}


## This is a wrapper function for the default plotting behavior of the QSarray object.
## By default, if the QSarray object contains data on less than 10 pathways, the function
## plotDensityCurves will be run on it. Otherwise, it will call the function plotCIs
setGeneric("plot", function(x,y,...) standardGeneric("plot"))
setMethod("plot", "QSarray", definition = 
  function(x, ##a QSarray object containing data from running aggregateGeneSet
           y, ##not used
           ...
          ){
    ##check if it's a combinedPDF
    if(!is.null(x$QSlist)){
      return(plotCombinedPDF(x,...))
    }
    
    pathNum = numPathways(x)
    if(is.na(pathNum)){stop("Nothing to plot. Run aggregateGeneSet first.")}  
    if(!is.null(list(...)$path.index)){pathNum=length(list(...)$path.index)}
    
    if(pathNum<10){invisible(plotDensityCurves(x,...))}
    else{plotCIs(x,...)}
  }
)


##override the normal "print" function for QSarrays
setGeneric("print", function(x) standardGeneric("print"))
setMethod("print", "QSarray", definition = 
  function(x,...){
    for(n in names(x)){
      cat("\n$",n,"\n")
      if(n %in% c("path.PDF")){
        cat("[",nrow(x[[n]]),"Points x",ncol(x[[n]]),"Gene Sets ]\n")
        
        ##going the long way about this to preserve the colnames of path.PDF
        
        print(head(as.matrix(x[[n]][,1:min(ncol(x[[n]]),5),drop=F])))
      }
      else if(n %in% "pathways"){
        if(length(x[[n]])>10){
          cat("[",length(x[[n]]),"Entries ]\n")
          print(summary(x[[n]][1:5]))
        }else{
          print(summary(x[[n]]))
        }
      }
      else{
        if(length(x[[n]])>30){
          cat("[",length(x[[n]]),"Entries ]\n")
          print(head(x[[n]]))
        }else{
          print(x[[n]])
        }
      }
    }
    invisible(x)
  }
)
setMethod("head", "QSarray", definition = 
  function(x, ...){invisible(print(x))}
)
          
## Briefly summarize the data in QSarray
setMethod("summary", "QSarray", definition = 
  function(object, ...){
    if(is.na(numPathways(object))){
      toKeep = c("contrast","var.method","mean","SD")
      ret = object[toKeep[toKeep %in% names(object)]]
      class(ret) = "QSarray"
      return(ret)
    }else{
      return(qsTable(object))
    }
  }
)


## This function prints a table with information on the gene sets in QSarray
qsTable = function(QSarray, number=20, sort.by=c("fdr","p","logFC")){
  if(is.null(numPathways(QSarray))){stop("No pathway information found.")}
  number = min(number, numPathways(QSarray))
  log.fold.change = QSarray$path.mean
  p.Value = pdf.pVal(QSarray)
  FDR = p.adjust(p.Value, method="fdr")
  #homogeneity.score = QSarray$homogeneity
  pathway.name = colnames(QSarray$path.PDF)
  
  if(is.null(log.fold.change)){log.fold.change = rep(NA, length(p.Value))}
  results = data.frame(pathway.name,log.fold.change,p.Value,FDR)#,homogeneity.score)
  rownames(results) = NULL
  
  if(sort.by[1]=="none"){sort.by=NULL}
  sort.by = match(sort.by, c("","logFC","p","fdr"))#,"homogeneity"))
  
  if(length(sort.by)>0){
    o = do.call(order, results[,sort.by,drop=F])
    results = results[o,]
  }
  return(results[1:number,])
}


# ###Override the functions for subsetting a QSarray object. 
# ## With this, you can subset a QSarray object using the [x] format, where x will select pathways.
# "[.QSarray" <- function(QSarray, x,...,drop){
#   if(length(list(...)>0)){stop("Incorrect number of dimensions")}
#   output = QSarray
#   for(n in names(QSarray)){
#     if(n %in% c("path.mean","path.size","vif")){
#       output[[n]] = QSarray[[n]][x]
#     }
#     if(n %in% c("path.PDF")){
#       output[[n]] = as.matrix(QSarray[[n]][,x,drop=F])
#     }
#   }
#   return(output)
# }

##a method to be called when trying to set a value of a QSarray object using the "$" operator
# "$<-.QSarray" <- function(QSarray, n, value){
#   if(n %in% c("dof","var.method","labels","contrast","design","range")){
#     if(!is.null(QSarray[[n]])){warning("This parameter was used in the generation of the data in this object. Changing this parameter may affect the results of other methods.")}
#     QSarray[[n]] <- value
#   }
#   if(n %in% c("mean","SD")){    ##things dependent upon nrow
#     if( is.null(QSarray[[n]]) && !is.na(nrow(QSarray)) && nrow(QSarray) != length(value) ||
#       !is.null(QSarray[[n]]) && length(QSarray[[n]])!=length(value) ){
#       stop("Replacement length not equal to the number of genes. If you are trying to subset the values of the QSarray object, use the '[,]' operator.")
#     }
#     QSarray[[n]] = value
#   }
#   if(n %in% c("path.mean","path.size","vif")){  ##things dependent upon ncol
#     if( is.null(QSarray[[n]]) && !is.na(ncol(QSarray)) && ncol(QSarray) != length(value) ||
#         !is.null(QSarray[[n]]) && length(QSarray[[n]])!=length(value) ){
#       stop("Replacement length not equal to the number of pathways. If you are trying to subset the values of the QSarray object, use the '[,]' operator.")
#     }
#     QSarray[[n]] = value
#   }
#   if(n %in% c("path.PDF")){  ##dependent on ncol and $n.points
#     if(!is.matrix(value)){value = as.matrix(value)}
#     if(!is.matrix(value)){stop("argument can not be coerced to a matrix")}
#     if( is.null(QSarray[[n]]) && !is.na(ncol(QSarray)) && ncol(QSarray) != ncol(value) ||
#       !is.null(QSarray[[n]]) && ncol(QSarray[[n]])!=ncol(value) ){
#       stop("Replacement length not equal to the number of pathways. If you are trying to subset the values of the QSarray object, use the '[,]' operator.")
#     }
#     QSarray[[n]] = value
#     if(!is.null(QSarray$n.points) && nrow(value) != QSarray$n.points){
#       warning("Number of rows does not match n.points. Updating n.points to match.")
#     }
#     QSarray$n.points = nrow(value)
#   }
#   if(n %in% c("n.points")){  ##dependent on $path.PDF
#     if(!is.numeric(value) || length(value) != 1){stop("value must be of length 1")}
#     if(!is.null(QSarray$path.PDF) && nrow(QSarray$path.PDF)!=value){
#       stop("n.points does not match nrows of path.PDF. To update this value, provide a new path.PDF matrix")
#     }
#     QSarray[[n]] = value
#   }
#   return(QSarray)
# }

##a method to be called when trying to set a value of a QSarray object using the "[" operator
##essentially: you can't do it.
# setMethod("[<-", "QSarray", definition = 
#   function(x, i,j,...,value){
#     stop("Can not replace parts of QSarray object.")
#   }
# )          
          
setGeneric("numFeatures", function(x) standardGeneric("numFeatures"))
setMethod("numFeatures", "QSarray", definition = function(x){
    ##calculate nrow from one of (mean, SD)
    genes = NA
    if(!is.null(x$mean)){genes = length(x$mean)}
    else if(!is.null(x$SD)){genes = length(x$SD)}
    return(genes)
  }
)
setGeneric("numPathways", function(x) standardGeneric("numPathways"))
setMethod("numPathways", "QSarray", definition = function(x){
    ##calculate ncol from one of (path.mean, path.size, path.PDF, vif)
    pathways = NA
    if(!is.null(x$path.mean)){pathways = length(x$path.mean)}
    else if(!is.null(x$path.size)){pathways = length(x$path.size)}
    else if(!is.null(x$path.PDF)){pathways = ncol(x$path.PDF)}
    else if(!is.null(x$vif)){pathways = length(x$vif)}
    return(pathways)
  }
)

##a method to return the dimensions of a QSarray object (i.e. the number of genes X the number of pathways)
setMethod("dim", "QSarray", definition = 
  function(x){
    return(c(numFeatures(x),numPathways(x)))
  }
)



# 
# ###The QScomb object contains data generated when running combinePDFs to 
# ## combine PDFs from different QuSage results objects.
# 
# ###Required Fields:
# ## x.coords        - Matrix describing the x coordinates of PDF(s), where each column is a 
# ##                   different gene set, and each row is a different point where this set 
# ##                   was sampled. 
# ## path.PDF        - Matrix describing the probability distributions for each of the 
# ##                   pathways provided to AggregateGeneSet, where each column is a 
# ##                   different gene set, and each row is a different point where this set 
# ##                   was sampled. 
# ## QSlist          - the original list of QSarray objects provided to combinePDFs. Each
# ##                   element of the list should be a valid QSarray object
# ## n.samples       - the number of samples in each dataset used to generate QSlist.
# ## path.names      - the vector of pathway names of each gene set.
# ## n.points        - the number of points that the PDF is sampled at. Should match 
# ##                   nrow(combined.PDF) and nrow(x.coords)
# 
# setClass("QScomb", representation("list"))
# newQScomb = function(obj=NULL,
#                              ...
# ){
#   output = list()
#   
#   if(!is.null(obj) & is.list(obj)){
#     for(n in names(obj)){
#       if(!is.null(output[[n]])){
#         warning("Parameter '",n,"' defined more than once. Overwriting parameter provided in obj")
#       }else{
#         output[[n]] = obj[[n]]
#       }
#     }
#   }
#   if(length(list(...))>0){
#     obj = list(...)
#     for(n in names(obj)){
#       if(!is.null(output[[n]])){
#         warning("Parameter '",n,"' defined more than once. Overwriting parameter provided in obj")
#       }
#       output[[n]] = obj[[n]]
#     }    
#   }
#   
#   ##check that requried fields are there, and that all the fields are allowed.
#   reqField = c("x.coords","path.PDF","QSlist","n.samples", "path.names", "n.points")
#   if(!any(reqField %in% names(output))){
#     stop("Missing required fields: ",paste(reqField[!(reqField %in% names(output))],collapse=", "))
#   }
#   if(!all(names(output) %in% reqField)){
#     stop("Field not used: ",paste(names(output)[!(names(output) %in% reqField)],collapse=", "))
#   }
#   
#   return(new("QScomb", output))
# }
# 
# 
# setGeneric("numDatasets", function(x) standardGeneric("numDatasets"))
# setMethod("numDatasets", "QScomb", definition = function(x){
#   ##calculate nrow from one of (mean, SD)
#   datasets = NA
#   if(!is.null(x$QSlist)){datasets = length(x$QSlist)}
#   else if(!is.null(x$n.samples)){datasets = length(x$n.samples)}
#   return(datasets)
# }
# )
# 
# setMethod("numPathways", "QScomb", definition = function(x){
#   ##calculate ncol from one of (path.mean, path.size, path.PDF, vif)
#   pathways = NA
#   if(!is.null(x$path.PDF)){pathways = ncol(x$path.PDF)}
#   else if(!is.null(x$path.names)){pathways = length(x$path.names)}
#   return(pathways)
# }
# )
# 
# ##a method to return the dimensions of a QSarray object (i.e. the number of genes X the number of pathways)
# setMethod("dim", "QScomb", definition = 
#             function(x){
#               return(c(numDatasets(x),numPathways(x)))
#             }
# )
# 
# 
# 
# ## This is a wrapper function for the default plotting behavior of the QScomb object.
# setMethod("plot",c(x="QScomb",y="missing"),function(x,  ##a QScomb object
#                                                     y,  ##when this is missing
#                                                     ...){
#   plotCombinedPDF(x,...)
# })
# setMethod("plot",c(x="QScomb",y="ANY"),function(x,  ##a QScomb object
#                                                 y,  ##if not missing, assumed to be path.index
#                                                 ...){
#   plotCombinedPDF(x,path.index=y,...)
# })

##########################################################################################
## "CombinedPDF" is the meta-analysis of QuSAGE that combines QuSAGE results from multiple 
## data sets. In this analysis, the QuSAGE probability density functions (PDFs) computed 
## for each data set were combined into one PDF for each gene set using numerical 
## convolution.
##########################################################################################
##
## Author: Hailong Meng, Gur Yarri, Chris Bolen
## Updated: 2015-07-29
## ? 2015 Yale University. All rights reserved.
##########################################################################################

## Plot the QScomb object for a specified pathway
plotCombinedPDF = function(QScomb, ##a QScomb object
                           path.index=1,
                           zeroLine=TRUE,
                           comb.lwd=3, path.lwd=1,
                           comb.col=par("col"), path.col=NULL,
                           legend=FALSE, legend.labs=NULL,
                           add=FALSE,
                           xlim=NULL,ylim=NULL,
                           xlab=NULL,ylab=NULL,main = NULL, 
                           type="l",
                           ...){
  
  
  if(!("QSarray" %in% class(QScomb))){
    stop("Input object must be of class 'QSarray'")
  }
  if(is.null(QScomb$QSlist)){
    stop("Input QSarray object does not appear to be the result of a call to combinePDFs")
  }
  
  ##check that path.index is of length 1 (since we can only plot one at a time)
  if(length(path.index)>1){ 
    stop("Cannot plot more than one pathway. path.index must be of length 1")
  }
  ##get pathway name to ensure consistency across individual QSarrays
  ##then convert path.index to an index
  if(!is.numeric(path.index)){
    path.name = path.index
    path.index = match(path.index, colnames(QScomb$path.PDF))
  }else{
    path.name = colnames(QScomb$path.PDF)[path.index]
  }

  ## ---------------------------------------------
  ## set defaults for undefined input variables
  
  ##calculate x and y limits
  if(is.null(xlim)){ 
    xlim = range(calcBayesCI(QScomb)[,path.index], na.rm=T)
    xlim = xlim + (xlim-mean(xlim))*2 ##double the range
    qs.xlims = lapply(QScomb$QSlist, function(QSarray){
      xlim = range(calcBayesCI(QSarray)[,path.index],na.rm=T) 
      xlim + (xlim-mean(xlim))*2
    })
    xlim = range(c(xlim, unlist(qs.xlims)))
  }
  
  comb.scaleFactor = pdfScaleFactor(QScomb)
  if(is.null(ylim)){ 
    ymax=max(QScomb$path.PDF[,path.index]/comb.scaleFactor[path.index],na.rm=T) 
    qs.ymax = lapply(QScomb$QSlist, function(QSarray){
      scaleFactor = pdfScaleFactor(QSarray)
      max(QSarray$path.PDF[,path.index]/scaleFactor[path.index],na.rm=T) 
    })
    ylim = c(0, max(c(ymax, unlist(qs.ymax))))
  }
  
  ##set default colors and line widths
  default.pal = c("#E41A1C","#377EB8","#4DAF4A","#984EA3","#FF7F00",
                  "#FFFF33","#A65628","#F781BF","#999999")
  if(is.null(comb.col)){comb.col = par("col")}
  
  if(is.null(path.col)){path.col = default.pal}
  if(length(path.col)!=length(QScomb$QSlist)){
    path.col = rep(path.col, length.out=length(QScomb$QSlist))
  }
  if(length(path.lwd)!=length(QScomb$QSlist)){
    path.lwd = rep(path.lwd, length.out=length(QScomb$QSlist))
  }

  ##default axes labels
  if(is.null(xlab)){xlab="Pathway Activity"}
  if(is.null(ylab)){ylab="Density"}
  if(is.null(main)){main = path.name} 

  #create plot region
  if(!add){
    plot(0,type='n', ylab=ylab, xlab =xlab, main=main, xlim=xlim, ylim=ylim, ...)
  }
  if(zeroLine){ abline(v=0, col = "gray", lty = "dotted",lwd=2) }
  
  ##add individual curves
  for(i in 1:length(QScomb$QSlist)){
    plotDensityCurves(QScomb$QSlist[[i]], path.index=path.name, add=T, col=path.col[i], 
                      lwd=path.lwd[i], zeroLine = F, type=type)
  }
  
  ##add main curve
  x = getXcoords(QScomb, path.index = path.index)
  y = QScomb$path.PDF[,path.index]/comb.scaleFactor[path.index]
  lines(x,y,col=comb.col, lwd=comb.lwd, type=type)

  ##add legend
  if((is.logical(legend) && legend) || is.character(legend)){
    legend_col = c(path.col, comb.col)
    if(is.null(legend.labs)){
      if(!is.null(names(QScomb$QSlist))){legend_text=c(names(QScomb$QSlist), "Meta Analysis")}
      else{legend_text = c(paste0("Dataset",1:length(QScomb$QSlist)), "Meta Analysis")}
    }else{
      legend_text = c(legend.labs, "Meta Analysis")
    }
    loc = ifelse(is.character(legend), legend, "topleft")
    legend(loc,legend=legend_text, fill=legend_col,bty="n")
  }
}

## A wrapper function to combine QuSAGE results from multiple data sets and returns a CombinedPDFResult object
combinePDFs <- function(QSarrayList,        ##list of qusage resutls from different data sets 
                        n.points = 2^14
  ){ 
  num.datasets = length(QSarrayList)
  ##check that input is formatted correctly
  # if there is no QuSAGE object in the input QuSAGE object list
  if(num.datasets==0 ){
    stop("There is no qusage result object in the input.")
  }
  # if there is only one  QuSAGE object in the input QuSAGE object list
  if(num.datasets==1 ){
    stop("There is only one qusage result object in the input.")
  }
  
  
  # if pathways of QuSAGE objects in the input QuSAGE object list do not match
  name.pathway = lapply(QSarrayList, function(x){names(x$pathways)})
  num.pathways = unique(sapply(name.pathway, length))
  if(length(num.pathways)==1){
    name.pathway = do.call(cbind,name.pathway)
  }
  if("list" %in% class(name.pathway) || any(name.pathway!=name.pathway[,1])){
    stop("The pathways in input QuSAGE objects do not totally match!")
  }

  ##pull sample size from the QSarray objects 
  ## (sum in case we're combining something we already combined)
  n.samples = sapply(QSarrayList, function(q){sum(q$n.samples)})  
  if(all(n.samples==0)){ n.samples = rep(1, length(n.samples))}
  
  ##calculate all the x-coordinates
  ## extract x coords from data set j
  X.lists = lapply(1:num.pathways, function(i){
    lapply(QSarrayList, getXcoords, path.index=i)
  })
  Min = sapply(X.lists, function(x){min(unlist(x),na.rm=T)})
  Max = sapply(X.lists, function(x){max(unlist(x),na.rm=T)})
  
  ## calculate combined PDFs for each pathway
  combined.PDF = sapply(1:num.pathways, function(i){ 
    X.list = X.lists[[i]]
    X.combined=seq(Min[i],Max[i],length.out=n.points)
    
    ## transform PDF to new X coordinates
    transformed.PDF = lapply(1:num.datasets, function(j){
      if(length(QSarrayList[[j]]$pathways[[i]])==0){
        warning("Dataset (index ",j,") contains no overlapping genes with pathway (index ",i,"). Excluding dataset from combined PDF.")
        return(NULL)
      }
      approx(X.list[[j]],QSarrayList[[j]]$path.PDF[,i],X.combined,rule=2)$y
    })
    toDrop = sapply(transformed.PDF, is.null)
    
    ##check to make sure at least one dataset has a PDF
    if(all(toDrop)){
      warning("No datasets found containing genes for pathway (index ",i,"). NAs produced")
      return(rep(NA, n.points))
      
    ##else, combine the PDF
    }else{
      transformed.PDF = do.call(cbind, transformed.PDF[!toDrop])
      ## combine PDFs and use sample size as weight parameter
      PDF.Combined<- calculate_bayesGHelper( list(transformed.PDF,n.samples[!toDrop]), n.points=n.points)
      
      NORM=(Max[i]-Min[i])/(n.points-1)
      combined.PDF.tmp <-PDF.Combined/NORM
      
      ##save data
      return(combined.PDF.tmp)
    }
  })
  ##make sure PDF.Combined is an array
  if(length(dim(combined.PDF))==0) combined.PDF<-t(matrix(combined.PDF))
  
  ##set column names
  colnames(combined.PDF) = name.pathway[,1]
  
  ##calculate the PDF means
  MEAN.PDFs<- sapply(1:num.pathways,function(i){
    if(!any(is.na(combined.PDF[,i]))){
      xin = seq(Min[i],Max[i],length.out=n.points)
      return(combined.PDF[,i] %*% xin / (sum(combined.PDF[,i])))
    }else{
      return(NA)
    }
  })
  
  ##calculate ranges (by taking the smaller tail)
  RANGES<- sapply(1:num.pathways,function(i){
    if (is.na(Max[i])) { return(NA) }
    return(min( (Max[i]-MEAN.PDFs[i]), (MEAN.PDFs[i]-Min[i]) ))
  })
  
  ##resample the PDFs to the new ranges
  PDF.COMBINED.RESAMPLED<-sapply(1:num.pathways,function(i){
    if (is.na(Max[i])) { return(rep(NA,n.points*2)) }
    
    xin = seq(Min[i],Max[i],length.out=n.points)
    xout = seq(MEAN.PDFs[i]-RANGES[i],MEAN.PDFs[i]+RANGES[i],length.out=n.points)
    return(approx(xin,combined.PDF[,i],xout)$y)
  })
  colnames(PDF.COMBINED.RESAMPLED) = colnames(combined.PDF)
  
  ##build up combined PDF result object
  results = newQSarray(path.PDF = PDF.COMBINED.RESAMPLED,
                       path.mean = MEAN.PDFs,
                       ranges = RANGES,
                       n.points = n.points,
                       QSlist = QSarrayList,
                       n.samples = n.samples
                     )

  return(results)
}
 
# ## Calculate one side p value for one single PDF
# cal.PValofCombinePDFs <- function (PDF, X_combined) 
# {
# 
#     null.hyp = 0
#     x = X_combined
#     PDF_NORM <- PDF/sum(PDF)
#     INDEX <- findInterval(null.hyp, x)
#     if (INDEX == 0) {
#         return(0)
#     }
#     if (INDEX == length(x)) {
#         return(1)
#     }
#     p=sum(PDF_NORM[1:INDEX]) + ((null.hyp - x[INDEX])/(x[INDEX + 
#         1] - x[INDEX])) * PDF_NORM[INDEX + 1]
# 
#     dir = "two.sided"
#     direction = FALSE
#     if (dir == "two.sided") {
#         p[which(p > 0.5)] = -1 + p[which(p > 0.5)]
#         p = ifelse(rep(direction, length(p)), p * 2, abs(p * 2))
#         return(p)
#     } 
#     return(p)
# }

## function calculate_bayesGHelper
calculate_bayesGHelper <- function( listMatG,n.points=2^14 ){
    matG <- listMatG[[1]]
    groups <- listMatG[[2]]
    i = 1
    resConv <- matG[,i]
    denom <- groups[i]
    if(length(groups)>1){
      while( i<length(groups) ){
        i = i + 1
        resConv <- weighted_conv(resConv, matG[,i], w= ((groups[i])/denom) ,n.points=n.points)
        #cat({{groups[i]}/denom},"\n")
        denom <- denom + groups[i]
      }
    }
    return(resConv)
}

## function weighted_conv 
weighted_conv<-function(x,y,w=1,m=100,n.points=4001){
  lx<-length(x)
  ly<-length(y)
  if( lx<m | (lx*w) < m | ly<m | (ly*w)<m ){
    if(w<1){
      y1<-approx(1:ly,y,seq(1,ly,length.out=m))$y
      x1<-approx(1:lx,x,seq(1,lx,length.out=m/w))$y
      lx<-length(x1)
      ly<-length(y1)
      
    } else {
      y1<-approx(1:ly,y,seq(1,ly,length.out=m*w))$y
      x1<-approx(1:lx,x,seq(1,lx,length.out=m))$y
      lx<-length(x1)
      ly<-length(y1)
    }
    
  } else{
    x1<-x
    y1<-approx(1:ly,y,seq(1,ly,length.out=floor(lx*w)))$y
    ly<-length(y1)
  }
  tmp<-approx(x=1:(lx+ly-1),y=convolve(x1,rev(y1),type="open"),xout=seq(1,lx+ly-1,length.out=n.points))$y
  tmp[tmp<=0] = 0 
  return(tmp/sum(tmp))
}

## This file contains methods for plotting the results in a QSarray object
##
## Author: Christopher Bolen
##         Gur Yaari
## Updated: 2013-03-15
## (c) 2013 Yale University. All rights reserved.


##Function for plotting out the pdfs of all the genes of a gene set
# QSarray1 -- an object of class QSarray.
# QSarray2 -- (optional) The output for a second comparison. 
#                 If provided, the function will add a second plot below the first to compare them.  
# path.index -- Which pathway in the QSarray object(s) to plot the PDF for. This can be of length 1 or 2 to specify different gene sets for the top and bottom plot. If QSarray2 is not specified and path.index is of length 2, the second plot will be drawn from QSarray1 
# normalizePeaks -- a boolean value. If true, curve heights will be normalized to the same value.
# alpha -- specifies the alpha channel for the individual gene density curves.
# addBarcode -- should the barcode plot be added below the PDFs
# barcode.col -- the color used for the bars of the barcode
# barcode.hei = height of the barcode as a fraction of the PDF plot
# groupLabel -- Vector of labels for the individual plots. If plotting two distributions, this must
#               be of length 2.
# labelLoc -- vector of length 1 or 2 determining the location on the plot of where to put the label. One of "left","center", or "right"
# xlab,ylab,main -- parameters to pass on to "plot"
# If you want to plot two curves, one below the other, geneResults2 (and optionally aggregatedData2)
# must be provided. 
plotGeneSetDistributions <- function(QSarray1, QSarray2=NULL, path.index=1, colorScheme="sdHeat",
                                     alpha=1, normalizePeaks=FALSE, addBarcode=TRUE, 
                                     barcode.col=NULL, barcode.hei = 0.2, groupLabel=NULL,labelLoc="left",
                                     xlab="Activity", ylab=NA, main=NULL,lwds=c(1,3),cex=1,...){
  ######################
  ## checking that all inputs are correct
  
  ##check path.index
  if(is.character(path.index)){
    temp = match(path.index, names(QSarray1$pathways))
    if(!is.null(QSarray2)){temp = c(temp, match(path.index, names(QSarray2$pathways)))}
    path.index = temp
  }
  if(!(length(path.index) %in% 1:2)){stop("path.index must be of either length 1 or 2")}
  
  ##get pathway genes
  if(length(path.index)==2){
    pathway1 = QSarray1$pathways[[path.index[1]]]
    pathway2 = QSarray1$pathways[[path.index[2]]]
    if(!is.null(QSarray2)){pathway2 = QSarray2$pathways[[path.index[2]]]}
  }else{
    pathway1 = pathway2 = QSarray1$pathways[[path.index]]
    if(!is.null(QSarray2)){pathway2 = QSarray2$pathways[[path.index]]}
  }
  if(length(pathway1)==0 || length(pathway2)==0){stop("Pathway in path.index has 0 genes")}
  
#   if(is.na(numPathways(QSarray1))){
#     QSarray1 = AggregateGeneSet(QSarray1,PathWayList=list(geneSet=pathway))
#   }
  if(is.null(QSarray2) & length(path.index)==2){
    twoPlots=T
    QSarray2 = QSarray1
    if(is.null(groupLabel)){groupLabel = names(QSarray1$pathways)[path.index]}
  }
  if(!is.null(QSarray2)){
    twoPlots=T
#     if(is.na(numPathways(QSarray2))){
#       QSarray2 = AggregateGeneSet(QSarray2,PathWayList=list(geneSet=pathway))
#     }
    if(is.null(groupLabel)){
      groupLabel = c(deparse(substitute(QSarray1)),deparse(substitute(QSarray2)))
    }
    if(length(groupLabel)!=2){
      if(length(groupLabel)==1 && groupLabel==""){groupLabel = c("","")}
      else{
        stop("Must provide two group labels if plotting two groups")
      }
    }  
  }else{
    twoPlots=F
    if(is.null(groupLabel)){
      groupLabel = c(deparse(substitute(QSarray1)))
    }
  }
  
  ## check color vectors
  if(length(colorScheme)>1 || length(barcode.col)>1){
    if(length(pathway1) != length(pathway2)){
      warning("Pathway 1 and Pathway 2 are different lengths. Using color vectors is not recommended.")
    }
    if(length(colorScheme)>length(pathway1)){
      stop("Length of colorScheme does not match length of pathway stored in QSarray1$pathways.")
    }
    if(length(barcode.col)>length(pathway1)){
      stop("Length of barcode.col does not match length of pathway stored in QSarray1$pathways.")
    }
  }
  
  ## set up labels
  labelLoc = match.arg(labelLoc, c("left","center","right"), several.ok=T)
  if(length(labelLoc)==1){labelLoc = rep(labelLoc,2)}
  
  #########################
  ##set up plotting area
  if(length(barcode.hei)!=1){stop("barcode.hei must be a numeric value of length 1")}
  if(twoPlots){
    if(addBarcode){
      layoutMat = matrix(c(1,4,5,7,6,2,3), ncol=1)
      hei = c(.3,1,barcode.hei,barcode.hei,1,.3,.2)
    }else{
      layoutMat = matrix(c(1,4,5,2,3), ncol=1)
      hei = c(.3,1,1,.3,.2)      
    }
  }else{
    if(addBarcode){
      layoutMat = matrix(c(1,4,5,2,3),ncol=1)
      hei = c(.3,1,barcode.hei,.2,.2)
    }else{
      layoutMat = matrix(c(1,4,2,3),ncol=1)
      hei = c(.3,1,.2,.2)
    }
  }
  layout(layoutMat,heights=hei)
  
  ##add title
  par(mar=c(0,0,0,0)); frame()
  if(!is.null(main)){
    text(0.5,0.5, main, cex=2*cex, font=2)
  }
  
  ##figure out the range for the x axis
  if(!is.null(list(...)$xlim)){
    xRange = list(...)$xlim
  }else{
    xRange = c(min(QSarray1$mean[pathway1]-3*QSarray1$SD[pathway1]),
               max(QSarray1$mean[pathway1]+3*QSarray1$SD[pathway1]))
    
    if(twoPlots){
      xRange2 = c(min(QSarray2$mean[pathway2]-3*QSarray2$SD[pathway2]),
                 max(QSarray2$mean[pathway2]+3*QSarray2$SD[pathway2]))
      xRange = range(c(xRange, xRange2))
    }
  }
  ##add the x axis
  par(mar=c(3,5,0,0))
  plot(0, xlim=xRange,axes=F, type="n",ylab="")
  X<-pretty(xRange,8)
  X<-X [X <= xRange[2] & X >= xRange[1] ]
  axis(1, X, X,cex=cex,...)
  
  ##add the x-label
  par(mar=c(0,5,0,0)); frame()
  text(0.5,0.5, xlab, cex=1.5*cex)
  
  ###############
  ## Generate the individual plots
  for(g in 1:(1+twoPlots)){
    QSarray = get(c("QSarray1","QSarray2")[g])
    pathway = get(c("pathway1","pathway2")[g])
    p.i = ifelse(length(path.index)==1,path.index, path.index[g])
    
    ##x coordinates for the main PDF
    set.x = getXcoords(QSarray, path.index=p.i)
    
    if(length(pathway)!=QSarray$path.size[p.i]){
      warning("length of 'pathway' does not match QSarray$path.size.")
    }
    
    ##plot main PDF
    if(!is.null(list(...)$ylim)){
      yRange = list(...)$ylim
    }else{
      setPeak = max(QSarray$path.PDF[,p.i]) / 
        ifelse(normalizePeaks, max(QSarray$path.PDF[,p.i])*0.25,pdfScaleFactor(QSarray)[p.i])
      
      genePeaks = dt(0,QSarray$dof[pathway])/QSarray$SD[pathway]
      if(normalizePeaks){genePeaks=1}
      gene.q = quantile(genePeaks,probs=0.9)
      
      yRange = c(0, 1.1)*max(gene.q, setPeak)
    }
    if(g==2){yRange = yRange[2:1]}
    par(mar=c(0,5,0,0))
    if(is.na(ylab)){ylab=ifelse(normalizePeaks,"","Density")}
    plot(0, xlim=xRange, ylim=yRange, type="n", axes=F,ylab=ylab,
         cex.axis=par()$cex.axis*cex,cex.lab=par()$cex.lab*cex)
    axis(2,cex=cex,...)
    
    ##add grey box for positive vs negative
    rect(0,-100,xRange[2],100, border=NA, col="#DDDDDD")
    
    ##add group label
    x = switch(labelLoc[g],
               left = xRange[1] + (xRange[2]-xRange[1])*0.05,
               center = xRange[1] + (xRange[2]-xRange[1])*0.5,
               right = xRange[2] - (xRange[2]-xRange[1])*0.05
              )
    text(x,yRange[g%%2+1] - (yRange[g%%2+1]-yRange[g])*0.1,
         groupLabel[g],pos=c(4,2)[1+(labelLoc=="right")], font=2, cex=1.5*cex)
    
    ##plot individual genes in order of their mean
    ord = order(QSarray$mean[pathway])
    
    ##Generate color scheme
    if(!("try-error" %in% class(try(col2rgb(colorScheme),silent=TRUE)))){
      ##if they provided colors
      cols = rep(colorScheme, length.out=length(pathway))
      ##if colorScheme is NA, use black
      if(length(colorScheme)==1 && is.na(colorScheme)){cols = rep("#000000", length.out=length(pathway))}
      
    }else if(colorScheme=="rainbow"){
      ##rainbow color scheme
      ##we want colors to be consistent between plots, so we define them for the pathway
      cols = rep(rainbow(10,alpha=alpha),length.out=length(pathway))
      cols = cols[order(ord)]
    } else if(colorScheme=="sdHeat"){
      ##SD Heatmap color scheme
      colFn = colorRamp(c("red","yellow","green","cyan","#00BBFF","#0088FF","#0044FF","#0000FF",
                          "#0000CC","#000099","#000077","#000055","#000033","#000022","#000011","black"))
      #peaks = log(dnorm(0,0,geneResults$data[2,pathway]))
      #peakRange = range(peaks)
      #cols = rgb(colFn((peaks-peakRange[1])/(peakRange[2]-peakRange[1]))/255)
      
      ## I decided I wanted the color range to be fixed, so I'm fixing the range of SDs from 0 to 1 
      ##  and setting anything above 1 to 1
      sds = QSarray$SD[pathway]
      sds[sds>1] = 1
      cols = rgb(colFn(sds)/255)
      cols = paste(cols, sprintf("%x",round(255*alpha)), sep="")
    }

    
    x.seq<-seq(xRange[1],xRange[2],length.out=1000)
    
    ##plot individual gene pdfs
    Max<-10
    for(i in ord){
      DT<-dt(seq(-Max,Max,length.out=10000),QSarray$dof[pathway[i]])
      mean = QSarray$mean[pathway[i]]; SD = QSarray$SD[pathway[i]]
      y.seq<-approx(x=seq(-Max,Max,length.out=10000),y=DT,xout=seq(-Max/SD,Max/SD,length.out=10000),rule=2)$y
      y.seq<-approx(x=seq(-Max,Max,length.out=10000)+mean,y=y.seq,xout=x.seq,rule=2)$y
      y.seq<-y.seq/(sum(y.seq)*(x.seq[2]-x.seq[1]))
#       divisor = ifelse(normalizePeaks, y.seq[findInterval(0,x.seq)],1)      
      divisor = ifelse(normalizePeaks, max((y.seq))/(max(yRange)/1.1/2),1)            
      y.seq<-y.seq/divisor
      lines(x.seq,y.seq,lwd=lwds[1],col=cols[i])
    }
    
    ##main pdf
    divisor = ifelse(normalizePeaks, max(QSarray$path.PDF[,p.i])*0.25,pdfScaleFactor(QSarray)[p.i])
    Y<-approx(set.x, QSarray$path.PDF[,p.i]/divisor,x.seq,rule=2)
    lines(Y,col=1, lwd=lwds[2])
    
    
    ##add barcode plot
    if(addBarcode){
      par(mar=c(0.2,5,0.2,0))
      plot(0, xlim=xRange, ylim=c(0,1), type="n", axes=F,ylab="")
      rect(0,-10,xRange[2],10, border=NA, col="#DDDDDD")
      
      ##line barcode
      if(is.null(barcode.col)){barcode.col="#222222"}
      abline(v=QSarray$mean[pathway],col=barcode.col)
      
      ##beeswarm barcode
#      require(beeswarm)
#      beeswarm(geneResults$data[1,pathway],horizontal=T,add=T,at=0.5,pch=16,cex=1)
    }
  }
  par(mar=c(5,4,4,2),mfrow=c(1,1)) ##reset the plotting window layout, so it's not quite as annoying
}


###A function for plotting the PDFs of a set of pathways. 
## This function uses the data produced by aggregateGeneSet to plot the PDFs of all the pathways in 
## QSarray. 
plotDensityCurves <- function(QSarray,       ##a QSarray object, containing the output of aggregateGeneSet.
                              path.index=1:numPathways(QSarray),    ##which pathways in QSarray to plot
                              zeroLine=TRUE, ##add a vertical line at 0
                              addVIF=!is.null(QSarray$vif),   ##use the VIF when calculating the spread of the pdf
                              col=NULL, ##colors for the curves. Defaults to R's standard colors.
                              plot=TRUE,
                              add=FALSE,  ##Boolean. If false, create a new plotting region to plot the curve to.
                              xlim=NULL,ylim=NULL, ##x- and y-limits of the plotting region.
                              xlab=NULL,ylab=NULL, ##x- and y-labels.
                              type="l",...){                ##additional parameters to pass to "plot.default"   
  
  ##check path.index
  if(is.character(path.index)){
    path.index = match(path.index, names(QSarray$pathways))
  }
  
  if(all(is.na(QSarray$path.mean[path.index]))){stop("no non-missing pathways in path.index")}
  
  scaleFactor = pdfScaleFactor(QSarray,addVIF=addVIF)
  
  if(is.null(xlim)){ xlim=range(calcBayesCI(QSarray,addVIF=addVIF)[,path.index],na.rm=T) 
                     xlim = xlim + (xlim-mean(xlim))*2
                   }
  if(is.null(ylim)){ ylim=range(t(QSarray$path.PDF[,path.index])/scaleFactor[path.index],na.rm=T) }
  
  if(is.null(xlab)){xlab="x"}
  if(is.null(ylab)){ylab="density"}
  
  if(is.null(col)){col=par("col")}

  if(!add & plot){
    plot(0, type="n", xlim=xlim, ylim=ylim,xlab=xlab,ylab=ylab, ...)
  }
  if(length(col)!=length(path.index)){
    col = rep(col, length.out=length(path.index))
  }
  if(zeroLine & plot){abline(v=0,lty=2)}
  
  retVal = list()
  
  for(i in 1:length(path.index)){
    path=path.index[i]
    x = getXcoords(QSarray,path,addVIF=addVIF)
    y = QSarray$path.PDF[,path]/scaleFactor[path]
    if(plot){
      lines(x, y, col=col[i],type=type,...)
    }
    retVal[[i]] = data.frame(x,y)
  }  
  
  ##invisibly return the x- and y- coordinates
  names(retVal) = colnames(QSarray$path.PDF)[path.index]
  invisible(retVal)
}

### Function for plotting the mean and confidence intervals of a set of pathways. 
plotCIs = function(QSarray, 
                   path.index=1:numPathways(QSarray), ##a numeric vector representing which gene sets to plot, and (if sort.by=="none") which order to plot them in. NAs will be removed if sort.by!="none", otherwise an empty column will be added.
                   sort.by=c("mean","p","none"),  ##how the pathways should be ordered.
                   lowerBound=0.025, ## lower bound for confidence interval
                   upperBound=1-lowerBound, ## upper bound for confidence interval 
                   col=NULL,     ##an optional vector indicating the color for the points. If use.p.colors=FALSE is specified, these colors will also be used for the error bars.
                   use.p.colors=TRUE, ##If true, color the points using p-values
                   p.breaks=NULL, ##a vector indicating where the breaks in the p-value color scheme should be. By default, breaks will be at 0.001, 0.005, 0.01, 0.05, & 0.1
                   p.adjust.method = "fdr", ##The method to use to adjust the p-values. Must be one of the methods in p.adjust.methods.
                   addLegend=use.p.colors, ##Should a legend for the p-value color scheme be plotted?
                   
                   lowerColorBar="none", ##Options for plotting a color bar below each point. If either "absolute" or "homogeneity" is specified, a color bar representing the values stored in the QSarray object will be added. If "none" is specified, no bar will be added. A numeric vector the same length as path.index can also be provided, and a color scheme will be created based on the values.
                   lowerColorBar.cols=NULL, ##a vector of colors to be used for the lower color bar.
                   
                   addGrid=TRUE,  ##Should guiding dashed lines be plotted?
                   x.labels=NULL, ##The labels for the individual pathways. By default, names(QSarray$path.mean)
                   cex.xaxis=1, ## set cex parameter manually for x axis label
                   shift=0.0,  ## shift of the x axis: shifts points and arrows (CI's) with respects to the guiding lines and axis labels. Useful when add=TRUE   
                   add=FALSE,    ##boolean parameter. If FALSE, a new plot is created. If TRUE, axes are not plotted
                   ylim=NULL, xlim=NULL,    ##the x- and y-limits of the plotting area
                   ylab=NULL, xlab=NULL,    ##x- and y- axis labels
                   main=NULL, ##plot title
                   sub=NULL, ##plot subtitle
                   type="p", ##plot type. one of "p"-points, "l"-line, or "b"-boths
                   ...){          ##additional parameters to pass to "plot.default"
  
  ##check path.index
  if(is.character(path.index)){
    path.index = match(path.index, names(QSarray$pathways))
  }
  
  if(all(is.na(QSarray$path.mean[path.index]))){stop("no non-missing pathways in path.index")}
  
  
  ###get values from QSarray
  means = QSarray$path.mean[path.index]
  CIs = calcBayesCI(QSarray,low=lowerBound,up=upperBound)[,path.index, drop=FALSE]
  p.vals = pdf.pVal(QSarray,direction=F)[path.index]
  p.vals = p.adjust(p.vals, p.adjust.method)
  p.vals = p.vals*sign(means)
  
  ##x labels
  if(is.null(x.labels)){
    x.labels=names(means)
  }
  
  ##get order of gene sets
  sort.by = match.arg(sort.by)
  if(sort.by=="mean"){ord = order(means, decreasing=T,na.last=NA)}
  else if(sort.by=="p"){ord = order(-log10(abs(p.vals))*sign(p.vals), decreasing=T,na.last=NA)}
  else{
    ord=1:length(means)
  }
  
  ##set plotting parameters
  originalPar = par(no.readonly=T)
  additional_args<-list(...)
  if(!"srt"%in%names(additional_args))par(srt=60)
  #if(!"pch"%in%names(additional_args))par(pch="x")
  par(...)

  ##color of the points
  if(!is.null(col)){   ##check that col is the correct length.  
    if(length(means) %% length(col) !=0 ){warning("length of col is not a multiple of input length")}
    col = rep(col, length.out=length(means))
  }else{
    col = rep(par("col"),length.out=length(means))
  }
  
  ###establish p-value color scheme
  if(is.null(p.breaks)){
    p.breaks = c(0.001,0.005,0.01,0.05,0.1)
  }else{
    p.breaks=abs(p.breaks)
    p.breaks=as.numeric(names(table(p.breaks)))
    p.breaks=p.breaks[p.breaks < 1 & p.breaks > 0]
    p.breaks = p.breaks[order(p.breaks)] ##make sure they're in ascending order
  }
  
  br.ln = length(p.breaks)
  p.breaks.twoSided<-c(-1,-rev(p.breaks),0,p.breaks,1)
  
  if(use.p.colors){
    p.colorScheme<-c(rgb(0,seq(0,1,length.out=br.ln+1),0),
                     rgb(seq(1,0,length.out=br.ln+1),0,0))
    bar.col = p.colorScheme[findInterval(p.vals,p.breaks.twoSided,rightmost.closed=T)]
    bar.col[which(p.vals==0)] = c("#00FF00","#FF0000")[(means>0)+1][which(p.vals==0)]
  }else{
    bar.col=col
  }
  
  if(is.null(xlab)){xlab=""}
  if(is.null(ylab)){ylab="Pathway Activity"}
  
  ##make plotting region
  if(!add){
    if(is.null(ylim)){ylim = range(CIs,na.rm=T)}
    plot(means[ord],type="n",las=1, ylim=ylim,  axes=FALSE,xlab=xlab,ylab=ylab,main=main,...)
    ##add guiding lines
    if(addGrid){abline(v=1:length(ord),col=gray(seq(0.5,1,length.out=10)),lty=2)}
    
    ##add axes
    axis(2,las=1,...)
    if(is.null(list(...)$xaxt) || list(...)$xaxt!="n"){
      Oldcex=par('cex')
      par(cex=0.5*Oldcex*cex.xaxis)
      #         axis(1, at=ord,las=2, labels=x.labels,...)
      axis(1, at=ord,las=2, labels=rep("",length(ord)),...)
      Ys<-par("usr")[3] -  par()$cxy[2]*par()$mgp[2]
      text(1:length(ord), Ys, adj = 1, labels = x.labels[ord], xpd = TRUE,...)
      par(cex=Oldcex)
    }
    abline(h=0,lty=2)
  }
  
  ##plot data
  arrows(1:length(ord)+shift, CIs[2,ord], 1:length(ord)+shift, CIs[1,ord],
         code=3,length=0.1,angle=90, col=bar.col[ord])
  points(1:length(ord)+shift,means[ord],type=type,col=col[ord],...)
  ##get x-axis labels
  if(is.null(x.labels))
    x.labels=names(QSarray$path.mean)[path.index]  
  
  
  ## add legend
  if(use.p.colors && addLegend && !add){
    ##the original color scheme 
    p.colorScheme<-c(rgb(0,seq(1,0,length.out=br.ln+1),0),
                     rgb(seq(0,1,length.out=br.ln+1),0,0))
    p.labels<-round(c(-p.breaks,1,rev(p.breaks)),3)
    n = length(p.labels)
    
    usr = par('usr')
    strsize = strwidth("W")  ##I need the height of a string oriented vertically, and it just happens that 'W' is approximately as wide as it is tall (in the default font).
    yvalues<-usr[4]-c(0,strheight("W")*1.5)
    xvalues<-usr[2]-(seq(strsize*(n+2),0,length.out=n+2)*1.2)
    
    text(mean(xvalues), yvalues[0]+strheight("X"), labels="P-values",pos=3,xpd=T)
    ##add boxes
    for(j in 1:(n+1)){
      polygon(c(xvalues[j],xvalues[j+1],xvalues[j+1],xvalues[j]),
              c(yvalues[1],yvalues[1],yvalues[2],yvalues[2]),
              col=p.colorScheme[j],border=p.colorScheme[j])
    }
    ##add labels
    for(j in 1:n){
      text(xvalues[j+1],yvalues[2]-strheight("W"),p.labels[j],adj=1,srt=90)
    }
  }
  
  ## add lower color bar
  lowBar.vals = NULL
  if(!is.character(lowerColorBar)){        ##### If plotting a random vector
    if(length(lowerColorBar)!=length(path.index)){
      warning("lowerColorBar not the same length as path.index. Color bar omitted")
    }else{
      lowBar.vals = lowerColorBar
      
      ##color scheme
      if(is.null(lowerColorBar.cols)){
        lowerColorBar.cols = rgb(seq(1,0,length.out=6),seq(1,0,length.out=6),1)
      }
      lowBar.breaks = seq(range(lowBar.vals)[1],range(lowBar.vals)[2],length.out=length(lowerColorBar.cols)+1)
    }
  }
  else if(lowerColorBar=="absolute"){     ###### If plotting absolute GST p-value
    if(is.null(QSarray$absolute.p)){
      warning("Absolute p-values not found. Color bar omitted.")
    }else{
      lowBar.vals = QSarray$absolute.p[path.index]
      lowBar.vals<-p.adjust(abs(lowBar.vals),method=p.adjust.method)
      
      ##color scheme
      lowBar.breaks = p.breaks.twoSided
      if(is.null(lowerColorBar.cols)){
        lowerColorBar.cols = c(rgb(0,seq(0,1,length.out=br.ln+1),0,0),
                               rgb(seq(1,0,length.out=br.ln+1),0,0))
      }
    }
  }
  else if(lowerColorBar=="homogeneity"){   ###### If plotting homogeneity score
    if(is.null(QSarray$homogeneity)){
      warning("Homogeneity score not found. Color bar omitted.")
    }else{
      lowBar.vals = QSarray$homogeneity[path.index]
      
      ##color scheme
      if(is.null(lowerColorBar.cols)){
        lowerColorBar.cols = rgb(seq(1,0,length.out=6),seq(1,0,length.out=6),1)
      }
      lowBar.breaks = seq(range(lowBar.vals)[1],range(lowBar.vals)[2],length.out=length(lowerColorBar.cols)+1)
    }
  }
  if(!is.null(lowBar.vals)){
    col = lowerColorBar.cols[findInterval(lowBar.vals,lowBar.breaks,rightmost.closed=T)]
    
    ###Plot box
    for(i in 1:length(ord)){
      usr = par()$usr;
      polygon(i+c(-0.5,-0.5,0.5,0.5), usr[3]+c(0.01,0.03,0.03,0.01)*(usr[4]-usr[3]),
              col=col[ord][i],border=col[ord][i])
    }
  }
  
  box(...)
  par(originalPar[c("srt","pch",names(list(...)))])
}





##Function for plotting out the pdfs of all the genes of a gene set

plotCIsGenes <- function(QSarray, ##an object of class QSarray.
                         path.index=1, ##the gene set name
                         gene.list=NULL,  ##Character vector. A predefined list of genes in the gene set to be plotted. If sort.by="none", the order of these genes will be used. NAs are accepted.
                         sort.by=NULL,  ##one of c(mean,p,none), specifying how to order the genes. If NULL and gene.list is provided, default is "none".
                         lowerBound=0.025, ## lower bound for confidence interval
                         upperBound=1-lowerBound, ## upper bound for confidence interval 
                         asBand=FALSE, ### plot CI as a grey band or as arrows
                         
#                          p.color.method="none", ##one of c("none","absolute","homogeneity")
#                          p.breaks=NULL, ##a vector indicating where the breaks in the p-value color scheme should be. By default, breaks will be at 0.001, 0.005, 0.01, 0.05, & 0.1
#                          p.adjust.method = "fdr", ##The method to use to adjust the p-values. Must be one of the methods in p.adjust.method.
#                          addLegend=p.color.method!="none", ##Should a legend for the p-value color scheme be plotted?
                         
                         col=NULL,     ##default color parameter to pass to "plot". If provided, it overrides "p.color.method"
                         addGrid=TRUE,  ##Should guiding dashed lines be plotted?
                         x.labels=NULL, ##The labels for the individual genes By default, names(QSarray$mean[gene.names]) or ORDER if not empty
                         cex.xaxis=1, ## set cex parameter manually for x axis label
                         shift=0.0,  ## shift of the x axis: shifts points and arrows (CI's) with respects to the guiding lines and axis labels. Useful when add=TRUE   
                         pathwayCI=c("band","bar","none"), ##A string, one of "band", "bar", or "none", determining whether to add the confidence interval for the gene set PDF to the plot. If "band", a band will be plotted behind the bars for the individual genes. If "bar" is specificied, another error bar will be added before the genes' error bars.
                         meanCol=4, ## color for the line that indicates the mean of the pathway
                         
                         add=FALSE,    ##boolean parameter. If FALSE, a new plot is created. If TRUE, axes are not plotted
                         ylim=NULL, xlim=NULL,    ##the x- and y-limits of the plotting area
                         ylab=NULL, xlab=NULL,    ##x- and y- axis labels
                         main=NULL, ##plot title
                         sub=NULL, ##plot subtitle
                         ...){          ##additional parameters to pass to "plot.default"
  
  ##check path.index
  if(is.character(path.index)){
    path.index = match(path.index, names(QSarray$pathways))
  }
  
  pathwayCI = match.arg(pathwayCI)
#   p.color.method=match.arg(p.color.method, c("none","absolute","homogeneity"))
  
  ###get values from QSarray
#   if(sum(!gene.names%in% names(QSarray$mean))){
#     warning("some gene names do not appear in QSarray object");
#     gene.names<-gene.names[gene.names%in% names(QSarray$mean)]
#   }
  if(sum(!is.na(path.index))==0){stop("pathway provided is not in QSarray")}
  if(sum(!is.na(path.index))>1){stop("more than one pathway provided")}
  gene.names<-names(QSarray$mean)[QSarray$pathways[[path.index]]]
  if(!is.null(gene.list)){
    gene.names = gene.list
  }
  
  if(is.na(QSarray$path.mean[path.index])){stop("pathway provided has length of 0")}
  
  
  means = QSarray$mean[gene.names]
  #ExistingGenes = 1:length(gene.names)
  #if(is.null(gene.list)){ExistingGenes=which(gene.list%in%gene.names)}
  
  ##calculate CIs for each gene
  CIs = sapply(gene.names,function(NAME){
    sd = QSarray$SD[NAME]*QSarray$sd.alpha[NAME]
    t.ci = qt(c(lowerBound,upperBound),QSarray$dof[NAME])
    return(QSarray$mean[NAME]+sd*t.ci)
  })
  #if(!length(dim(CIs)))CIs<-matrix(CIs)
  
  
  ##Get P-values for each gene
#   p.vals = sapply(gene.names,function(NAME)pt((QSarray$mean[NAME]-QSarray$path.mean[pathway.name])/(QSarray$SD[NAME]*QSarray$sd.alpha[NAME]),QSarray$dof[NAME]))
#   p.vals [ p.vals > 0.5 ] = 1-p.vals [ p.vals > 0.5 ]
#   p.vals = 2 * p.vals
#   p.vals = p.adjust(p.vals, p.adjust.method)
#   p.vals = p.vals*sign(means-QSarray$path.mean[pathway.name])
#   p.vals=NULL
#   if(p.color.method %in% c("absolute","homogeneity")){
#     p.vals = absoluteTest.genePvals(QSarray,path.index,compareTo=ifelse(p.color.method=="absolute","z","p"))[[1]]
#     p.vals = p.adjust(abs(p.vals), p.adjust.method)
#     p.vals = p.vals*sign(means-QSarray$path.mean[path.index])
#     p.vals = p.vals[gene.names]
#   }
  
  ##get order of gene sets
  if(is.null(sort.by)){sort.by = c("mean","none")[2-is.null(gene.list)]}
  sort.by = match.arg(sort.by, c("mean","p","none"))
  if(sort.by=="mean"){
    ord = order(means, decreasing=T,na.last=NA)
  }else if(sort.by=="p"){
    sd = QSarray$SD*QSarray$sd.alpha
    t.stat = QSarray$mean/(sd/sqrt(QSarray$dof+2))
    p.val = dt(t.stat,QSarray$dof)
    ord = order(-log10(p.val[gene.names])*sign(t.stat), decreasing=T, na.last=NA)
  }else{
    ord=1:length(means)
  }
  
  ##set up plotting region
  originalPar = par(no.readonly=T)
  additional_args<-list(...)
  if(!"srt"%in%names(additional_args))par(srt=60)
  if(!"pch"%in%names(additional_args))par(pch="x")
  par(...)
  
  ###establish p-value color scheme
  if(!is.null(col)){   ##if they specify "col", we won't worry about a p-value color scheme.  
    if(length(ord) %% length(col) !=0 ){warning("length of col is not a multiple of input length")}
    col = rep(col, length.out=length(ord))
  }else{
#     if(is.null(p.breaks)){
#       p.breaks = c(0.001,0.005,0.01,0.05,0.1)
#     }else{
#       p.breaks = abs(p.breaks)
#       p.breaks = as.numeric(names(table(p.breaks)))
#       p.breaks = p.breaks[p.breaks < 1 & p.breaks > 0]
#       p.breaks = p.breaks[order(p.breaks)] ##make sure they're in ascending order
#     }
#     
#     br.ln = length(p.breaks)
#     p.breaks.twoSided<-c(-1,-rev(p.breaks),0,p.breaks,1)
#     
#     if(!is.null(p.vals)){
#       p.colorScheme<-c(rgb(0,seq(0,1,length.out=br.ln+1),0),
#                        rgb(seq(1,0,length.out=br.ln+1),0,0))
#       col = p.colorScheme[findInterval(p.vals,p.breaks.twoSided,rightmost.closed=T)]
#     }else{
       col=rep(par("col"),length.out=length(means))
#     }
   }
  
  if(is.null(xlab)){xlab=""}
  if(is.null(ylab)){ylab="Gene Activity"}
  if(is.null(main)){main=names(QSarray$pathways)[path.index]}
  

  ##plot data
  if(!add){
    if(is.null(ylim)){ylim = range(CIs,na.rm=T)}
    xlim=c(1,length(ord))
    if(pathwayCI=="bar")xlim=c(0,length(ord))
    plot((1:length(ord)),means[ord],type="n",las=1, ylim=ylim,  axes=FALSE,xlab=xlab,ylab=ylab,xlim=xlim, main=main,...)
    
    ##add guiding lines
    if(addGrid){
      abline(v=1:length(ord),col=gray(seq(0.5,1,length.out=10)),lty=2)
    }
  }
  
  ## confident band for pathway PDFs
  if(pathwayCI=="band"){
    CI_Path = calcBayesCI(QSarray,low=lowerBound,up=upperBound)[,path.index]
    usr = par()$usr
    polygon(c(usr[1],usr[1],usr[2],usr[2]),c(CI_Path[1],CI_Path[2],CI_Path[2],CI_Path[1]),border=grey(0.9),col=grey(0.9))
    abline(h=QSarray$path.mean[path.index],lty=4,col=meanCol)
  }

  
  if(pathwayCI=="bar"){
    CI_Path = calcBayesCI(QSarray,low=lowerBound,up=upperBound)[,path.index]
    points(shift,QSarray$path.mean[path.index],...)
    arrows(shift, CI_Path[1], shift, CI_Path[2],
        code=3,length=0.1,angle=90, col=1,lwd=2)
    abline(h=QSarray$path.mean[path.index],lty=4,col=meanCol)
  }
  
  if(!asBand){
      points(1:length(ord)+shift, means[ord], type="p", col=col[ord],...)
      arrows(1:length(ord)+shift, CIs[2,ord], 1:length(ord)+shift, CIs[1,ord],
       code=3,length=0.1,angle=90, col=col[ord])
  }
  else{
      polygon(c(1:length(ord)+shift,length(ord):1+shift),c(CIs[2,ord],CIs[1,rev(ord)]),border=grey(0.8),col=grey(0.8))
      points(1:length(ord)+shift,means[ord],type="l",col=col[ord])
  }

  ##get x-axis labels
  if(is.null(x.labels))
    x.labels=gene.names[ord]
  ##add axes
  if(!add){
    axis(2,las=1)
    if(is.null(list(...)$xaxt) || list(...)$xaxt!="n"){
        Oldcex=par('cex')
        par(cex=0.5*Oldcex*cex.xaxis)
#         axis(1, at=ord,las=2, labels=x.labels,...)
         axis(1, at=ord,las=2, labels=rep("",length(ord)),...)
         
         Ys<-par("usr")[3] -  par()$cxy[2]*par()$mgp[2]
        text(1:length(x.labels), Ys, adj = 1,
          labels = x.labels, xpd = TRUE,...)
        if(pathwayCI=="bar"){axis(1, at=0,las=2, labels="",...)}
        if(pathwayCI=="bar"){
          text(0, Ys, adj = 1,labels = names(QSarray$pathways)[path.index], xpd = TRUE,...) 
        }
        par(cex=Oldcex)
    }
    abline(h=0,lty=1,lwd=0.5)   
  }
  ## add legend
#   if(!is.null(p.vals) && addLegend){
#     ##the original color scheme 
#     p.colorScheme<-c(rgb(0,seq(1,0,length.out=br.ln+1),0),
#                      rgb(seq(0,1,length.out=br.ln+1),0,0))
#     p.labels<-round(c(-p.breaks,1,rev(p.breaks)),3)
#     n = length(p.labels)
#     
#     usr = par('usr')
#     strsize = strwidth("W")  ##I need the height of a string oriented vertically, and it just happens that 'W' is approximately as wide as it is tall (in the default font).
#     yvalues<-usr[4]-c(0,strheight("W")*1.5)
#     xvalues<-usr[2]-(seq(strsize*(n+2),0,length.out=n+2)*1.2)
#     
#     text(mean(xvalues), yvalues[0]+strheight("X"), labels="P-values",pos=3,xpd=T)
#     ##add boxes
#     for(j in 1:(n+1)){
#       polygon(c(xvalues[j],xvalues[j+1],xvalues[j+1],xvalues[j]),
#               c(yvalues[1],yvalues[1],yvalues[2],yvalues[2]),
#               col=p.colorScheme[j],border=p.colorScheme[j])
#     }
#     ##add labels
#     for(j in 1:n){
#       text(xvalues[j+1],yvalues[2]-strheight("W"),p.labels[j],adj=1,srt=90)
#     }
#   }
   ###Plot box
  box(...)
  par(originalPar[c("srt","pch",names(list(...)))])
}

\name{read.gmt}
\alias{read.gmt}

\title{
  Read in gene set information from .gmt files
}
\description{
This function reads in and parses information from the MSigDB's .gmt files. Pathway information will be returned as a list of gene sets.
}
\usage{
read.gmt(file)
}

\arguments{
  \item{file}{The .gmt file to be read}
}
\details{
The .gmt format is a tab-delimited list of gene sets, where each line is a separate gene set. The first column must specify the name of the gene set, and the second column is used for a short description (which this function discards). For complete details on the .gmt format, refer to the Broad Institute's Data Format's page (url: \url{http://www.broadinstitute.org/cancer/software/gsea/wiki/index.php/Data_formats}).
}
\value{
  A list, where each index represents a separate gene set. 
}

\section{Warning}{
  The function does not check that the file is correctly formatted, and may return incorrect or partial gene sets, e.g. if the first two columns are omitted. Please make sure that files are correctly formatted before reading them in using this function.
}

 \name{plotDensityCurves}
 \alias{plotDensityCurves}
 \title{Plot gene set PDFs}
 \description{
   A function for plotting out the pdfs of a set of pathways.
 }
 \usage{
plotDensityCurves(QSarray,
                  path.index=1:numPathways(QSarray),
                  zeroLine=TRUE,
                  addVIF=!is.null(QSarray$vif),
                  col=NULL,
                  plot=TRUE,
                  add=FALSE,
                  xlim=NULL,ylim=NULL,
                  xlab=NULL,ylab=NULL,
                  type="l",
                  \dots)
 }
 \arguments{
    \item{QSarray}{QSarray object}
    \item{path.index}{vector describing which pathways to plot. Can either be numeric or a character vector containing the names of the pathways to plot.}
    \item{zeroLine}{a logical indicating whether to include a vertical line at 0.}
    \item{addVIF}{a logical indicating whether the VIF should be used to calculate the variance of the pathway.}
    \item{col}{the color of the curves. Can be a vector of the same length as path.index specifying the color of each individual curve.}
    \item{plot}{Logical indicating whether to create the plot. If \code{FALSE}, only the coordinates for the plot will be returned, and no new plot will be created.}
    \item{add, xlim, ylim, xlab, ylab, type, \dots}{parameters to be passed on to \code{plot}}

 }
 \details{
This function uses the data produced by aggregateGeneSet to plot the PDFs of the pathways in QSarray. By default, \code{plotDensityCurves} will plot a curve for each pathway in the QSarray pathway, but this behavior can be controlled by the \code{path.index} parameter. For the best plots, it is suggested that you limit the number of curves plotted to below ten. 
  
 }
 \value{
   Invisibly returns a list of the same length as path.index, where each entry is a matrix of x- and y-coordinates for that pathway.
 }
 
 \examples{
   ##create example data
  eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
  labels = c(rep("A",10),rep("B",10))
    
  ##genes 1:30 are differentially expressed
  eset[1:30, labels=="B"] = eset[1:30, labels=="B"] + 1
  geneSets = list(diff.set=1:30, base.set=31:60)
  
  ##Run qusage
  set.results = qusage(eset, labels, "B-A", geneSets)
 
  ##Plot results
  plotDensityCurves(set.results)
  
  ##plot just the first curve with a different color
  plotDensityCurves(set.results, path.index=1, col=2, lwd=2)
  
  ##plot the CDFs of the curves
  coords = plotDensityCurves(set.results, plot=FALSE)
  plot(0, type="n", xlim=c(-1,2),ylim=c(0,1),xlab="x",ylab="CDF")
  for(i in 1:length(coords)){
    points = coords[[i]]
    x = points$x
    y = cumsum(points$y)/sum(points$y)
    lines(x,y,col=i)
  }
  
 }

 \name{getXcoords}
 \alias{getXcoords}
 \title{Get the X coordinates for the points of the PDF}
 \description{
   Calculates the x-coordinates for the PDF of a given pathway.
 }
\usage{
getXcoords(QSarray, path.index=1, addVIF=!is.null(QSarray$vif))

}
\arguments{                                              
    \item{QSarray}{A QSarray object as output by \link{qusage} (or \link{aggregateGeneSet})}
    \item{path.index}{either an integer between 1 and numPathways(QSarray), or the name of the pathway to retrieve.}
    \item{addVIF}{a logical indicating whether to use the VIF when calculating the variance}
}
\details{
   The calculation of the x-coordinates for a PDF is not straightforward, and as such they are not included in the QSarray object initially. During the numerical convolution step, the gene set PDF is calculated at a number of points (equal to \code{QSarray$n.points}) over a range defined by:
   
  \code{c(path.mean - range, path.mean + range})
   
  However, the resulting PDF is actually the \emph{sum} of the individual gene PDFs, rather than the desired \emph{average} PDF. Therefore the range which is stored in the resulting QSarray is divided by the number of genes in the pathway, \code{QSarray$path.size}.
  
  In addition, the width of the PDF can be expanded by the Variance Inflation Factor (VIF), which is equivalent to multiplying the range of the x-coordinates by the \code{sqrt(VIF)}. If the parameter \code{addVIF=TRUE}, the VIF calculatd using the \code{calcVIF} method will be included in the calculation of the x-coordinates.
  
  In general, the x-coordinates for a pathway are calculated for each point n using the following formula:
  
  \deqn{x_n = (-1+\frac{2(n-1)}{N_{pts}-1}) \times r \times \sqrt{VIF} + \hat{\mu}_{path}}{x.n = ( seq(-1,1,length.out=N.points) * range * sqrt(VIF) ) + path.mean}
}
 
 \value{
   A numeric vector of length \code{QSarray$n.points}.
 }
 \examples{
 
  ##create example data
  eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
  labels = c(rep("A",10),rep("B",10))
   
  ##first 30 genes are differentially expressed
  eset[1:30, labels=="B"] = eset[1:30, labels=="B"] + 1
  geneSets = list(diff.set=1:30, base.set=31:60)
  
  ##Run qusage
  set.results = qusage(eset, labels, "B-A", geneSets)
  
  ##Plot the PDF (see also: plotDensityCurves() )
  x = getXcoords(set.results, 1)
  y = set.results$path.PDF[,1]
  plot(x,y, type="l")
 }

 \name{newQSarray}
 \alias{newQSarray}
 \title{The qusage Array Object}
 \description{
   The constructor for the QSarray object. Should primarily be used internally by \code{\link{qusage}} or \code{\link{makeComparison}}. See \code{\link{QSarray-class}} for a full description of the fields in the QSarray object.
 }
 \usage{
newQSarray(obj=NULL,
        \dots
       )
 }
 \arguments{ 
    \item{obj}{The features of QSarray can be supplied as a list of objects. The objects in the list must be named appropriately. See \code{\link{QSarray-class}} for a description of the parameters which can be stored in the QSarray object.}
    \item{\dots}{The fields of the QSarray object can also be specified individually. If \var{obj} is specified and additional fields are provided, the parameters will be combined together into a single QSarray object, with the parameters specified by \dots replacing those in \var{obj} (this will also produce a warning).}

}
\details{
This is the constructor for use in creating QSarray objects. This is primarily intended for internal use, but advanced users may find it useful to construct their own QSarray objects without going through the process of running qusage.

In order to create a QSarray object from scratch, the constructor requires the following three fields: \code{mean}, \code{sd}, and \code{dof}. All other fields can be either left blank or added after. Note that in some cases, various methods will not be able to run without more information. For a complete list of the fields that the QSarray object can contain, refer to \code{\link{QSarray-class}}.
}

\name{GeneSets}
\docType{data}
\alias{GeneSets}
\alias{MSIG.geneSets}
\alias{ISG.geneSet}
\alias{BTM.geneSets}
\title{Example Gene Sets}
\description{
  \describe{
  \item{ISG.geneSet}{A vector contains a list of probable ISGs based on Schoggins et al. (Nature, 2011).}
  \item{MSIG.geneSet}{A list containing a set of vectors representing the MSigDB's Canonical Pathways gene set database.}
  \item{BTM.geneSet}{A list containing a set of vectors. Each entry describes one of the blood transcription modules (BTMs) from Li et al (Nat Immunol., 2014)}
  }
}
\usage{
  ISG.geneSet
  MSIG.geneSets
  BTM.geneSet
}
\format{}
\source{\url{http://www.broadinstitute.org/gsea/msigdb/}}
\references{
 ISG: Schoggins et al. (Nature, 2011).
 
 MSIG: Liberzon et al. (Bioinformatics, 2011)
 
 BTM: Li et al. (Nat Immunol., 2014).
}
\keyword{datasets}

 \name{calcBayesCI}
 \alias{calcBayesCI}
 \title{Calculate pathway Confidence Intervals}
 \description{
   A function to calculate the confidence intervals for each of the gene sets in the \var{geneResults} object
 }
 \usage{
calcBayesCI(QSarray,low=0.025,up=1-low,addVIF=!is.null(QSarray$vif))
 }
 \arguments{
    \item{QSarray}{A \code{QSarray} object, as generated by either makeComparison or aggregateGeneSet}
    \item{low, up}{the lower and upper bounds of the confidence interval.}
    \item{addVIF}{a logical indicating whether the VIF should be used to calculate the variance of the pathway.}
 }
 \details{
 This function can be used to calculate a confidence interval (CI) for the gene sets in \code{QSarray}. By default, a 95\% CI is calculated, with the lower and upper bounds at \code{0.025\%} and \code{0.975\%}, respectively. This function is used in \link{plotCIs} to plot the confidence intervals of each pathway.
 }
 
 \value{
   Matrix of size (\code{2 x numPathways(QSarray)}) containing the lower and upper bounds of the confidence intervals for each pathway in \code{QSarray}.
 }

 \name{plotGeneSetDistributions}
 \alias{plotGeneSetDistributions}
 \title{Plot gene and gene set PDFs}
 \description{
   A function for plotting out the pdfs of all the genes in a gene set
 }
 \usage{
plotGeneSetDistributions(QSarray1, QSarray2=NULL, 
                         path.index=1, 
                         colorScheme="sdHeat",
                         alpha=1,
                         normalizePeaks=FALSE,
                         
                         addBarcode=TRUE,
                         barcode.col=NULL,
                         barcode.hei=0.2,
                         
                         groupLabel=NULL,
                         labelLoc="left",
                         xlab="Activity", 
                         ylab=NA, 
                         main=NULL,
                         lwds=c(1,3),
                         cex=1,
                         \dots)
 }
 \arguments{
    \item{QSarray1, QSarray2}{QSarray objects containing PDFs of a gene set}
    \item{path.index}{either an integer between 1 and numPathways(QSarray), or the name of the pathway to retrieve. This can be of length 1 or 2 to specify different gene sets for the top and bottom plot (see details)}
    \item{colorScheme}{This parameter specifies the color scheme to be used when plotting the individual gene PDFs. This can either be one of c("rainbow", "sdHeat") for a customized color scheme, or a vector of colors of the same length as the gene set. See the details section for more information.}
    \item{alpha}{numeric value between 0 and 1 specifying the alpha channel for the individual gene curves. Only used if \code{colorScheme} is set to one of "rainbow" or "sdHeat"}
    \item{normalizePeaks}{logical indicating whether curve heights will be normalized to the same value.}
    \item{addBarcode}{logical indicating whether a barcode-style plot should be added below the PDFs representing the means activity of each individual gene.}
    \item{barcode.col}{The color used for the bars of the barcode plot. Can be a vector of colors, or a single color which is repeated for each bar in the plot.}
    \item{barcode.hei}{a numeric value specifying the height of the barcode plot relative to the size of the PDF plot.}
    \item{groupLabel}{Vector of labels for the individual plots. If left blank, labels will be generated automatically.}
    \item{labelLoc}{vector of length 1 or 2 determining the location on the plot of where to put the label. One of "left","center", or "right"}
    \item{lwds}{a numeric vector of length 2 specifying the lwd parameters for the gene and gene set curves, respectively.}
    \item{xlab, ylab, main, cex, ...}{parameters to be passed on to \code{plot}}

 }
 \details{
  The \code{plotGeneSetDistribution} function is designed to provide a quick and intuitive look at how individual genes contribute to the overall expression of a gene set. This function plots the PDFs of each individual gene in a gene set alongside the convoluted PDF of those genes. In addition, a barcode plot representing the location of the mean fold change of each individual gene is added by default below the plot. The appearance of the curves can be controlled by the \code{colorScheme} and \code{alpha} parameters, and the barcode plot by \code{addBarcode}, \code{barcode.col}, and \code{barcode.hei}.
  
  The default \code{colorScheme}, sdHeat, will automatically color-code the gene PDFs by their standard deviations, with hotter colors being used for smaller standard deviations. This, along with \code{colorScheme="rainbow"}, are the only automatic color schemes, but \code{colorScheme} also accepts custom colors. This can be a vector of colors in any format accepted by \code{par(col)}. If the vector provided is shorter than the number of genes in the gene set, the vector will be repeated. NOTE: The order that the colors are used in is not the same as the order of genes in the original gene set. All gene sets are reordered when they are stored in the \code{QSarray$pathways} slot, and the vector provided to \code{colorScheme} will be used in this order. This also applies to any colors provided to \code{barcode.col}
  
  By default, the first pathway in the QSarray object will be plotted. If you wish to change this parameter, you can provide an alternatve pathway using the \code{path.index} parameter. This can either be an integer between 1 and \code{numPathways(QSarray1)}, or it can be a string representing the name of the pathway. 
  
  The \code{plotGeneSetDistribution} function can also be used to compare the results from two different pathways or datasets. In order to analyze two different pathways from the same QSarray object, you can provide a \code{path.index} parameter of length 2 representing the two pathways to be compared. Alternatively, a separate QSarray object can be provided as the parameter \code{QSarray2}, and the second plot will be drawn from this object. If \code{QSarray2} is provided and \code{path.index} is of length 2, the second \code{path.index} will be drawn from \code{QSarray2}.
  
  
 }
 
 \examples{
 
 ##create example data
   eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
   labels = c(rep("A1",5),rep("A2",5),rep("B1",5),rep("B2",5))
   
##first 30 genes are differentially expressed much more strongly in group "B" than in group "A"
   geneSet = 1:30
   eset[geneSet, labels=="A2"] = eset[geneSet, labels=="A2"] + 1
   eset[geneSet, labels=="B2"] = eset[geneSet, labels=="B2"] + 2
   
##calculate qusage results
   A.results = qusage(eset,labels, "A2-A1", geneSet)
   B.results = qusage(eset,labels, "B2-B1", geneSet)

##plot the gene set distribution for group A and group B side-by-side
  plotGeneSetDistributions(A.results,B.results)
  
##add labels to the right side of the plots
  plotGeneSetDistributions(A.results,B.results,groupLabel = c("A2-A1", "B2-B1"), labelLoc="right")
  
##change the colors of the curves
  plotGeneSetDistributions(A.results,B.results, colorScheme="rainbow")
 }

\name{fluExample}
\docType{data}
\alias{fluExample}
\alias{eset.full}
\alias{flu.meta}
\title{Example gene expression set}
\description{
 This is a matrix containing microarray gene expression values taken from a publicly available dataset (GEO ID: GSE30550; Huang Y et al. PLoS Genet 2011). This dataset contains samples from 17 patients who were exposed to Influenza and had blood drawn approximately every 8 hours for a week. Patients were classified as either symptomatic (sx) or asymptomatic (asx) based on the severity of their symptoms.
 
 The portion of the dataset included here contains a total of 15 time points, including a pre-exposure point (time 0) and points approximately every 8 hours up to 108 hours. \code{eset.full} is arranged by donor, and the information for each sample is contained in a table, \code{flu.meta}. The metadata table contains 7 columns: 
 \describe{
  \item{\code{SampleID}}{The GEO sample IDs, matching the column names of eset.full}
  \item{\code{Subject}}{the subject ID}
  \item{\code{Hours}}{The hour-post-infection that the sample was collected (stored as a factor)}
  \item{\code{Hours.Numeric}}{Same as above, but stored as a numeric vector}
  \item{\code{Condition}}{The condition of the donor, either symptomatic (sx) or asymptomatic (asx)}
  \item{\code{Gender}}{The donor gender}
  \item{\code{Age}}{Age of the donor at recruitment}
 }
}
\usage{
  eset.full
  flu.meta
}
\format{\code{eset.full} is a matrix of gene expression measurements, with rows of genes and columns representing samples. \code{flu.meta} is a data frame, with rows of samples and columns of metadata information.}
\source{\url{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE30550}}
\references{
 Huang Y et al. (PLoS Genet 2011)
}
\keyword{datasets}

 \name{makeComparison}
 \alias{makeComparison}
 \title{Compare Genes Between Two Groups}
 \description{
   A function to calculate comparisons between groups in a dataset.
 }
 \usage{
 makeComparison(eset, labels, contrast, pairVector=NULL, 
                var.equal = FALSE, bayesEstimation = TRUE, 
                min.variance.factor=10^-8)
 }
 \arguments{
    \item{eset}{An objet of class \link[Biobase]{ExpressionSet} containing log normalized expression data (as created by the affy and lumi packages), OR a matrix of log2(expression values), with rows of features and columns of samples}
    \item{labels}{Vector of labels representing each column of eset}
    \item{contrast}{A string describing which of the groups in \var{labels} we want to compare. This is usually of the form \sQuote{trt-ctrl}, where \sQuote{trt} and \sQuote{ctrl} are groups represented in \var{labels}.}
    \item{pairVector}{A vector of factors (usually just 1,2,3,etc.) indicating which samples are paired. This is often just a vector of patient IDs or something similar. If not provided, all samples are assumed to be independent.}
    \item{var.equal}{A logical variable indicating whether to treat the two variances as being equal. If TRUE then the pooled variance is used to estimate the variance otherwise the Welch approximation is used.}
    \item{bayesEstimation}{A logical variable. If true, use a bayesian framework to estimate the standard deviation (via limma's eBayes function).}
    \item{min.variance.factor}{A factor to add to the SDs to ensure that none are equal to 0. Only used if var.equal==FALSE or bayesEstimation==FALSE.}

 }
 \details{
  This function is the first step in the qusage algorithm.  It defines the t-distributions for each gene in the input dataset by calculating the fold change and standard deviation between two groups of samples.
  
  There are two primary methods to compare two groups of data, based on whether variances of the genes in the two groups should be considered equal (as specified by the the parameter var.equal).  If var.equal=F, the t-distributions are estimated using a Welch's formalism, which is implemented internally.  Else, the LIMMA package is used to calculate the t-distribution of each gene using a pooled formalism.
  
  A note on var.equal: LIMMA's linear model function can only be run when assuming equal variances.  If var.equal==TRUE, then a linear model will be created on the entire dataset at once.  One benefit of using LIMMA's pooled variance calculation is that the linear models allow for more complicated comparisons (e.g. "(A+B)-C" or similar).  This may be of interest to some users, but in order to do this, you must assume equal variances between all groups.
  
  One caveat regarding paired samples: LIMMA can not fit a linear model when the paired samples are convoluted with the groups (e.g. one set of paired (trt vs mock) samples in patients with  disease, combined with a set of paired samples from healthy controls).  If var.equal==TRUE, these groups must be run separately to correctly fit the model (e.g. run disease first, then healthy controls).
 }
 \value{
   A \link[=QSarray-class]{QSarray} object.
 } 
 \examples{
 
  ##create example data
  eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
  labels = c(rep("A",10),rep("B",10))
   
  ##first 30 genes are differentially expressed
  eset[1:30, labels=="B"] = eset[1:30, labels=="B"] + 1
   
  ##compare the two groups
  results = makeComparison(eset, labels, "B-A")
  
## Paired Samples
  ##Group A and group B are two samples from the same set of 10 patients
  pairVector = c(1:10,1:10)
  results.paired = makeComparison(eset, labels,"B-A",pairVector=pairVector)
  
 }

 \name{pVal}
 \alias{pdf.pVal}
 \alias{oneWay.pVal}
 \alias{twoCurve.pVal}
 \alias{twoWay.pVal}
 \title{Calculate p-values for gene set activity}
 \description{
   Methods for calculating the significance of gene set activity, compared either to a null hypothesis (\code{pdf.pVal}), or to a separate PDF (\code{twoCurve.pVal}).
 }
\usage{
pdf.pVal(QSarray, alternative=c("two.sided","less","greater"),
         direction=FALSE, addVIF=!is.null(QSarray$vif), selfContained=TRUE)
            
twoCurve.pVal(grp1, grp2, path.index1 = 1:numPathways(grp1), path.index2 = 1:numPathways(grp2), 
              alternative=c("two.sided","less","greater"), direction=FALSE, 
              addVIF=!(is.null(grp1$vif) | is.null(grp2$vif)))
}
\arguments{                                              
    \item{QSarray, grp1, grp2}{A QSarray object as output by \link{qusage} (or \link{aggregateGeneSet})}
    \item{alternative}{a character string specifying the alternative hypothesis, must be one of "two.sided" (default), "greater" or "less". You can specify just the initial letter.}
    \item{direction}{a logical indicating whether the p-values should be signed (i.e. negative fold changes return negative p-values). Ignored if \code{alternative!="two.sided"}.}
    \item{addVIF}{a logical indicating whether to use the VIF when calculating the variance}
    \item{selfContained}{a logical indicating whether the test should be self-contained or competitive. See details for more information.}
    \item{path.index1, path.index2}{numeric vectors indicating which gene sets in grp1 to compare to grp2. The length of path.index1 and path.index2 must match.}
}
\details{
   The pVal functions are designed to estimate the level of significance for the gene set activity cacluated using qusage. Because the QSarray object contains gene set information stored as a Probability Density Function (PDF), we can determine significance of an individual gene set using the \code{pdf.pVal} function by comparing the PDF to our null hypothesis (zero by default. See below).  If \code{alternative="greater"}, \code{pdf.pVal} tests whether the fold change of the gene set is greater than the null mean, and the p-value is calcuated based on the proportion of the lower tail of the PDF which is below the null hypothesis.
   
   There are two options for the null hypothesis in this method, controlled by the logical parameter "\code{selfContained}". By default, \code{pdf.pVal} performs a self-contained test, where the null hypothesis is that the mean fold change is 0. If \code{selfContained=FALSE} is specified, \code{pdf.pVal} instead performs a competitive test, where the null hypothesis is the mean fold change of all genes which are not in the pathway.
   
   An individual gene set's PDF can also be compared with a second PDF, created from either comparing a different set of samples or using a different gene set, using the \code{twoCurve.pVal} function. This function takes two QSarray objects, \code{grp1} and \code{grp2}, and by default compares the PDFs for each gene set in the two QSarray objects in order. However, this behavior can be controlled by the \code{path.index1} and \code{path.index2} parameters, which are numeric vectors specifying which gene sets should be compared. The two vectors must be the same length, and the first index in \code{path.index1} will be compared with the first index in \code{path.index2} and so on. 
}
 
 \value{
   A vector of p-values for each gene set in QSarray, or for each gene set specified with \code{path.index} when using \code{twoCurve.pVal}.
 }
 \examples{
##create example data
   eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
   labels = c(rep("A1",5),rep("A2",5),rep("B1",5),rep("B2",5))
   
   geneSets = list()

##first 30 genes are differentially expressed for the 2 vs. 1 comparison
   geneSets[["simple.diffSet"]] = 1:30
   eset[geneSets[[1]], labels=="A2"] = eset[geneSets[[1]], labels=="A2"] + 1
   eset[geneSets[[1]], labels=="B2"] = eset[geneSets[[1]], labels=="B2"] + 1
   
##second set of 30 genes different in only group B
   geneSets[["complex.diffSet"]] = 31:60
   eset[geneSets[[2]], labels=="B2"] = eset[geneSets[[2]], labels=="B2"] + 1
   
#a third gene set of non-D.E. genes
   geneSets[["normSet"]] = 61:90

##calculate qusage results
   A.results = qusage(eset,labels, "A2-A1", geneSets)
   B.results = qusage(eset,labels, "B2-B1", geneSets)

##calculate p-values for initial comparison
   pdf.pVal(A.results)
   pdf.pVal(B.results)
 
##compare the pdfs of the two groups
  twoCurve.pVal(A.results,B.results)
 }

\name{fluVaccine}
\docType{data}
\alias{fluVaccine}
\title{Gene expression sets from Flu Vaccine trials}
\description{
  \code{fluVaccine} is a list containing data from two separate Flu Vaccine treatment studies, \code{GSE59635} and \code{GSE59654}. The top-level list contains two entries, \code{esets} and \code{phenoData}.
  
  \code{fluVaccine$esets} is a list containing two expression matrices. Each matrix, which is labeled with the name of the GEO dataset it originates from, contains rows of gene expression levels and columns of samples.
  
  \code{fluVaccine$phenoData} is a list containing two data frames. The rows of each data frame correspond to the columns in the expression matrices, and each data frame contains the following columns:
  \describe{
    \item{subjectID}{The subject ID}
    \item{responder}{Factor describing the subject's response to flu vaccination, either "high" or "low".}
    \item{bloodDrawDay}{The day post-vaccination that the sample was taken.}
  }
}
\usage{
  fluVaccine
}
\format{\code{fluVaccine} is a list.}
\source{
  \url{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE59635}
  \url{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE59654}
}
\references{
 Thakar J et al., Aging, 2015
}
\keyword{datasets}

 \name{qusage}
 \alias{qusage}
 \title{Run qusage on an expression dataset}
 \description{
   A wrapper function for the three primary steps in the qusage algorithm
 }
 \usage{
qusage(eset, labels, contrast, geneSets, pairVector=NULL,
       var.equal=FALSE, filter.genes=FALSE, n.points=2^12)
 }
 \arguments{
    \item{eset}{An objet of class \link[Biobase]{ExpressionSet} containing log normalized expression data (as created by the affy and lumi packages), OR a matrix of log2(expression values), with rows of features and columns of samples}
    \item{labels}{Vector of labels representing each column of eset}
    \item{contrast}{A string describing which of the groups in 'labels' we want to compare. This is usually of the form 'trt-ctrl', where 'trt' and 'ctrl' are groups represented in 'labels'}
    \item{geneSets}{Either a list of pathways to be compared, or a vector of gene names representing a single gene set. See Description for more details.}
    \item{pairVector}{A vector of factors (usually just 1,2,3,etc.) describing the sample pairings. This is often just a vector of patient IDs or something similar. If not provided, all samples are assumed to be independent.}
    \item{var.equal}{A logical variable indicating whether to treat the two variances as being equal. If TRUE then the pooled variance is used to estimate the variance otherwises the Welch approximation is used.}
    \item{filter.genes}{A boolean indicating whether the genes in eset should be filtered to remove genes with low mean and sd.}
    \item{n.points}{The number of points at which to sample the convoluted t-distribution. This should be increased when running qusage with a small number of samples (i.e. 6 or less in total). See \code{\link{aggregateGeneSet}} for more information.}

 }
 \details{
  This function runs the entire qusage method on the input data, returning a single QSarray object containing the results of the three primary steps in the qusage algorithm: \link{makeComparison}, \link{calcVIF}, and \link{aggregateGeneSet}. Many of the parameters are left out of this function for simplicity, so for greater control each of the functions must be called separately.
  
  Gene sets are commonly obtained from online databases such as Broad's Molecular Signatures Database. Gene set lists can be obtained from these sites in the form of .gmt files, which can be read into R using the \code{\link{read.gmt}} function. Once the data has been read into R, the information can be passed into the qusage function as either a vector describing a single gene set, or a list of vectors representing a group of gene sets. Each pathway must be a character vector with entries matching the row names of \var{eset}. If a pathway does not contain any values matching the rownames of \var{eset}, a warning will be printed, and the function will return NAs for the values of that pathway.
  
 }
 
 \value{
   A \link[=QSarray-class]{QSarray} object.
 }
 \examples{
 
##create example data - a set of 500 genes normally distributed across 20 patients
  eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
  labels = c(rep("A",10),rep("B",10))
   
##create a number of gene sets with varying levels of differential expression.
  geneSets = list()
  for(i in 0:10){
    genes = ((30*i)+1):(30*(i+1))
    eset[genes,labels=="B"] = eset[genes,labels=="B"] + rnorm(1)
    
    geneSets[[paste("Set",i)]] = genes
  }
   
   
##calculate qusage results
  results = qusage(eset,labels, "B-A", geneSets)
 
 
 }

 \name{calcVIF}
 \alias{calcVIF}
 \title{Calculate Variance Inflation Factor}
 \description{
   A function to calculate the Variance Inflation Factor (VIF) for each of the gene sets in the \var{geneResults} object
 }
 \usage{
calcVIF(eset, geneResults, useCAMERA = geneResults$var.method=="Pooled", 
        useAllData = TRUE)
 }
 \arguments{
    \item{eset}{An objet of class \link[Biobase]{ExpressionSet} containing log normalized expression data (as created by the affy and lumi packages), OR a matrix of log2(expression values). This must be the same dataset that was used to create geneResults}
    \item{geneResults}{A \code{QSarray} object, as generated by either makeComparison or aggregateGeneSet}
    \item{useCAMERA}{The method used to calculate variance. See the description for more details.}
    \item{useAllData}{Boolean parameter determining whether to use all data in eset to calculate the VIF, or to only use data from the groups being contrasted. Only used if useCAMERA is set to FALSE}
 }
 \details{
 This method calculates the Variance Inflation Factor (VIF) for each gene set in \var{geneSets}, which is used to correct for the correlation of genes in the gene set. This method builds off of a technique proposed by Wu et al. (Nucleic Acids Res, 2012), which calculates the VIF for each gene set based on the correlation of the genes in that set. The Wu et al. method, referred to as CAMERA, uses the linear model framework created by LIMMA to calculate gene-gene correlations, but consequently it must assume equal variance not only between all groups in the dataset, but also across each gene in the gene set. While this assumption leads to a slightly more computationally efficient VIF calculation, it is not valid for most gene sets, and its violation can greatly impact specificity.
 
 This function provides two options for calculating the VIF: the CAMERA method established by Wu et al. (if \var{useCAMERA} is \code{TRUE}), or an alternative implementation of the VIF calculation (if \var{useCAMERA} is \code{FALSE}) which does not assume equal variance of individual groups or genes. By default, \code{calcVIF} will choose \var{useCAMERA} based on the options specified in \link{makeComparison}. If \code{var.equal} was set to \code{TRUE}, then by default the variance will be calculated using CAMERA. 
 
 If the internal VIF calculation is used (i.e. \code{useCAMERA=FALSE}), the parameter \var{useAllData} can be specified to determine which samples in \var{eset} should be used to calculate the VIF. By default (\code{useAllData=TRUE}), all of the samples in \var{eset} will be used to calculate the VIF. If \code{useAllData=FALSE}, only the samples in \var{eset} which were used to generate \var{geneResults} will be included in the calculation. Generally, using all data will provide a more accurate esimate of the gene-gene correlations, but if the samples in \var{eset} are from very different conditions (e.g. different tissues or platforms), it may make more sense to limit the VIF calculation to a subset of samples.
 }
 
 \value{
   A version of \var{geneResults} with VIF added into the object.
 }
 \examples{
 
  ##create example data
  eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
  labels = c(rep("A",10),rep("B",10))
  
  ##a few of the genes are made to be strongly correlated
  corGenes = t(apply(eset[1:30,],1,sort))
  eset[1:30,] = corGenes[,sample(1:ncol(eset))]
  
  ##genes 1:60 are differentially expressed
  eset[1:60, labels=="B"] = eset[1:60, labels=="B"] + 1
  geneSets = list(cor.set=1:30, random.set=31:60)
  
  ##Run qusage
  geneResults = makeComparison(eset, labels, "B-A")
  set.results = aggregateGeneSet(geneResults, geneSets)
  
  ##calc VIF for gene sets
  set.results = calcVIF(eset, set.results)
 
  ##Look at results with and without VIF
  par(mfrow=c(1,2))
  plotDensityCurves(set.results, addVIF=FALSE, col=1:2, main="No VIF")
  plotDensityCurves(set.results, addVIF=TRUE, col=1:2, main="With VIF")
  legend("topleft",legend=names(geneSets),col=1:2, lty=1)
  
 }

 \name{plotCIsGenes}
 \alias{plotCIsGenes}
 \title{Plot Gene Mean and Confidence Intervals}
 \description{
   Functions for plotting the mean and confidence intervals of the genes in a pathway.
 }
 \usage{
plotCIsGenes(QSarray, 
             path.index=1,
             gene.list=NULL,
             sort.by=NULL, 
             lowerBound=0.025,
             upperBound=1-lowerBound,
             asBand=FALSE,
                   
             col=NULL,                   
             addGrid=TRUE,
             x.labels=NULL, 
             cex.xaxis=1,
             shift=0.0,
             pathwayCI=c("band","bar","none"),
             meanCol=4,
                   
             add=FALSE,
             ylim=NULL, xlim=NULL,
             ylab=NULL, xlab=NULL,
             main=NULL,
             sub=NULL,
             \dots
             )
 }
 \arguments{
    \item{QSarray}{QSarray object}
    \item{path.index}{which pathway to plot. Can either be numeric or a character vector containing the names of the pathways to plot. Must be of length 1}
    \item{gene.list}{Character vector specifying the genes in the gene set to be plotted. If \code{sort.by='none'}, the order of these genes will be used. NAs are accepted.}
    \item{sort.by}{one of c(mean,p,none), specifying how to order the genes. If NULL and gene.list is provided, default is "none", else, default is "mean".}
    \item{lowerBound, upperBound}{numeric indicating the lower and upper bounds of the confidence intervals. Default is for a 95\% confidence interval.}
    \item{asBand}{logical indicating if CIs should be plotted as a grey band or as arrows}
    \item{col}{an optional vector indicating the color for the points.}
    \item{addGrid}{Should guiding dashed lines be plotted?}
    \item{x.labels}{character vector indicating the names of the genes to be plotted along the x-axis. By default, will use the names stored in QSarray, or \code{gene.list}, if specified.}
    \item{cex.xaxis}{set cex parameter seperately for x axis label}
    \item{shift}{a number between 0 and 1 decribing the amount to shift points with respects to the guiding lines and axis labels. Useful when add=TRUE}
    \item{pathwayCI}{A string, one of "band", "bar", or "none", determining whether to add the confidence interval for the gene set PDF to the plot. By default ("band"), a band will be plotted behind the bars for the individual genes. If "bar" is specificied, another error bar will be added before the genes' error bars. To suppress the plotting of the pathway band, specify \code{pathwayCI="none"}.}
    \item{meanCol}{color for the line indicating the mean of the pathway. Only used if \code{pathwayCI} is either \code{'band'} or \code{'bar'}}
    \item{add}{logical indicating whether a new plot should be created. If \code{FALSE}, a new plot will be generated.}
    \item{xlim, ylim, xlab, ylab, main, sub,\dots}{parameters to be passed on to \code{plot}. If \code{NULL}, defaults will be used.}

 }
 \details{
This function uses the data produced by \code{\link{makeComparison}} to plot the means and confidence intervals of the genes in an individual gene set. To only plot the means and CIs of a subset of the genes in a pathway, a list of the genes to be plotted can be specified using the \code{gene.list} parameter. By default, the genes will be ordered by decreasing mean, and the 95\% confidence intervals of each point will be added. To specify a different order, \code{sort.by} must be set to \code{"none"}, and the order specified by \code{gene.list} will be used.

The mean of the overall pathway will automatically be added as a dashed line (with color specified by \code{meanCol}), but information on the confidence interval of the aggregated pathway can optionally be plotted as well. If \code{pathwayCI} is set to either "band" or "bar", the mean and CI of the gene set will be added to the plot. Specifying "band" will add the CI as a band behind the individual points, whereas "bar" will add an additional point at the left side of the plot with the mean and CI of the pathway itself. 

 }
 
 \examples{
##create example data
   eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
   labels = c(rep("A",10),rep("B",10))
   
##first 30 genes are differentially expressed for the 2 vs. 1 comparison
   diffSet = 1:30
   eset[diffSet, labels=="B"] = eset[diffSet, labels=="B"] + 1
   
#a second gene set of non-D.E. genes
   normSet = 31:60

   geneSets = list(diffSet=diffSet, normSet=normSet)

##calculate qusage results
   results = qusage(eset,labels, "B-A", geneSets)
   
##Plot gene data from first gene set
   plotCIsGenes(results, path.index=1)
   
##Add a bar to represent the differential expression of the gene set
   plotCIsGenes(results, path.index=1, pathwayCI="bar")
 }

\name{QSarray-class}
\docType{class}
\alias{QSarray-class}
\alias{dim,QSarray-method}
\alias{head,QSarray-method}
\alias{numFeatures}
\alias{numPathways}
\alias{numFeatures,QSarray-method}
\alias{numPathways,QSarray-method}
\alias{plot,QSarray-method}
\alias{print,QSarray-method}
\alias{summary,QSarray-method}

\title{Class \code{"QSarray"}}
\description{
   A list-based class which contains the results of running qusage. Generally created by \code{\link{qusage}} or \code{\link{makeComparison}}
}
\section{Objects from the Class}{
QSarray objects should not be created directly, but rather through the \code{\link{makeComparison}} function. They can also be created manually via a call to the \code{\link{newQSarray}} function, although this should be done by advanced users only.
}
\section{Components}{
  \code{QSarray} objects do not contain any slots (apart from \code{.Data}) but they should contain the following list components:
  \tabular{ll}{
    {\code{mean}} \tab { numeric vector containing mean fold changes for individual genes}\cr \cr 
    {\code{SD}} \tab {numeric vector of standard deviations for individual genes}\cr 
    {\code{dof}} \tab {numeric vector. Degrees of Freedom for each gene}\cr 
    {\code{var.method}} \tab {one of \code{("Welch's","Pooled")}, indicating the method used to calculate the variance}\cr 
    {\code{sd.alpha}} \tab {The factor each sd is multiplied by (either due to the min.variance.factor parameter in makeComparison or because of the Bayesian shrinkage of the SDs). This is used when calculating the VIF in order to correct for genes with 0 (or very small) variance.}\cr 
    {\code{labels}} \tab {The labels as input in makeComparisons, describing the group structure of the data.}\cr 
    {\code{pairVector}} \tab {A vector indicating which samples should be treated as pairs.}\cr 
    {\code{contrast}} \tab {A string describing which of the two groups in labels was compared.}\cr 
  }
  
  The following additional components are appended to the object by running \code{\link{aggregateGeneSet}} and \code{\link{calcVIF}}
  
  \tabular{ll}{ 
    {\code{pathways}} \tab {the list of genes in each gene set. Represented as a list of indices.}\cr 
    {\code{path.mean}} \tab {vector describing the mean fold change for each of the pathways provided to AggregateGeneSet}\cr 
    {\code{path.PDF}} \tab {Matrix describing the probability distributions for each of the pathways provided to AggregateGeneSet, where each column is a different gene set, and each row is a different point where this set was sampled. x-coordinates must be generated using \code{\link{getXcoords}}}\cr 
    {\code{path.size}} \tab {numeric vector containing the number of features in each pathway that mapped to the input data.}\cr 
    {\code{ranges}} \tab {the (uncorrected) range that all PDFs were calculated over. If the VIF is not used to correct the range, the x-coordinates of the PDF are the sequence of n.points from \code{path.mean-ranges} to \code{path.mean+ranges}}\cr 
    {\code{n.points}} \tab {The number of points that the PDF was calculated at. This is equal to the number of rows in \code{path.PDF}}\cr 
    {\code{vif}} \tab {the Variance Inflation Factor for each pathway, as calculated by \code{\link{calcVIF}}}
  }
}

\section{Methods}{
  \describe{
  
    \item{newQSarray}{ The constructor for the QSarray object. Should primarily be used internally by \code{\link{qusage}} or \code{\link{makeComparison}}. See \code{\link{newQSarray}} for additional details.}
  
    \item{numFeatures}{Returns the number of features (i.e. genes or probesets) in the dataset}
    \item{numPathways}{Returns the number of pathways provided to \code{\link{aggregateGeneSet}} }
    \item{dim}{dimensions of the QSarray object, as c(numFeatures, numPathways) }
    \item{print, head}{Prints a summarized version of all fields in the QSarray object.}
    \item{summary}{Prints a brief summary of the QSarray object.}
    \item{plot}{Plots the information stored in QSarray by either calling \code{\link{plotDensityCurves}} (if \code{numPathways} < 10) or \code{\link{plotCIs}} (if \code{numPathways} >= 10)}
    \item{qsTable}{Print a table with a summary of the information on the most significant gene sets in QSarray. See \code{\link{qsTable}} for more details.}
	 }
}
\author{
Christopher Bolen
}
\keyword{classes}

 \name{qsTable}
 \alias{qsTable}
 \title{Summary of QSarray Results}
 \description{
   Print a table with a summary of the information on the most significant gene sets in QSarray.
 }
 \usage{
qsTable(QSarray, number=20, sort.by=c("fdr","p","logFC"))
 }
 \arguments{
    \item{QSarray}{A QSarray object}
    \item{number}{The number of gene sets to include in the table}
    \item{sort.by}{character vector; a list of metrics to be used to sort the gene sets in QSarray. Can be any combination and order of \code{c("fdr","p","logFC")}, or \code{NULL} to specify no re-ordering of gene sets.}
 }
 \details{
 This method will return a table with a summary of the results of qusage. 
 }
 
 \value{
   A data frame containing the following columns:
   \itemize{
     \item \code{pathway.name} - The name of the pathway
     \item \code{log.fold.change} - Average log2 fold change value of the genes in the pathway
     \item \code{p.Value} - The p-value for the gene set, as calculated using \code{pdf.pVal}
     \item \code{FDR} - The Benjamini-Hochberg False Discovery rate. Calculated using R's built-in \code{p.adjust} method.
   }
 }
 \examples{
 ##create example data
  eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
  labels = c(rep("A",10),rep("B",10))
   
  geneSets = list()

##create a number of gene sets with varying levels of differential expression.
  for(i in 0:10){
    genes = ((30*i)+1):(30*(i+1))
    eset[genes,labels=="B"] = eset[genes,labels=="B"] + rnorm(1)
    
    geneSets[[paste("Set",i)]] = genes
  }
   
   
##calculate qusage results
  results = qusage(eset,labels, "B-A", geneSets)
   
  qsTable(results)
  
##show the first 5 sets, sorted by log fold change
  qsTable(results, number=5, sort.by="logFC")
 }

 \name{plotCIs}
 \alias{plotCIs}
 \title{Plot Pathway Mean and Confidence Intervals}
 \description{
   Functions for plotting the mean and confidence intervals of a set of pathways.
 }
 \usage{
plotCIs(QSarray, 
        path.index=1:numPathways(QSarray),
        sort.by=c("mean","p","none"), 
        lowerBound=0.025,
        upperBound=1-lowerBound,
                   
        col=NULL,
        use.p.colors=TRUE,
        p.breaks=NULL,
        p.adjust.method = "fdr",
        addLegend=use.p.colors,
        lowerColorBar="none",
        lowerColorBar.cols=NULL,
                   
        addGrid=TRUE,
        x.labels=NULL, 
        cex.xaxis=1,
        shift=0.0,
                   
        add=FALSE,
        ylim=NULL, xlim=NULL,
        ylab=NULL, xlab=NULL,
        main=NULL,
        sub=NULL,
        type="p",
        \dots
        )
 }
 \arguments{
    \item{QSarray}{QSarray object}
    \item{path.index}{vector describing which pathways to plot. Can either be numeric or a character vector containing the names of the pathways to plot.}
    \item{sort.by}{One of c("mean","p","none") indicating the order that the pathways should be plotted in. If "none", the pathways will not be reordered, and the order specified in path.index will be maintained}
    \item{lowerBound, upperBound}{numeric indicating the lower and upper bounds of the confidence intervals. Default is for a 95\% confidence interval.}
    \item{col}{an optional vector indicating the color for the points. If \code{use.p.colors=FALSE} is specified, these colors will also be used for the error bars.}
    \item{use.p.colors}{logical indicating whether error bars should be colored based on the significance of the p-value.}
    \item{p.breaks}{a vector indicating where the breaks in the p-value color scheme should be. By default, breaks will be at 0.001, 0.005, 0.01, 0.05, & 0.1}
    \item{p.adjust.method}{The method to use to adjust the p-values. Must be one of the methods in \code{\link{p.adjust.methods}}.}
    \item{addLegend}{a logical specifying if a legend for the p-value color scheme be plotted}
    \item{lowerColorBar}{Options for plotting a color bar below each point. Automatically generated color bars have not yet been implemented, but custom bars can be created using the "lowerColorBar.cols" parameter.}
    \item{lowerColorBar.cols}{a vector of colors to plot as a bar below each point.}
    \item{addGrid}{Should guiding dashed lines be plotted?}
    \item{x.labels}{character vector of the same length as \code{path.index} giving the names of the pathways. By default, will use the names stored in QSarray.}
    \item{cex.xaxis}{set cex parameter seperately for x axis label}
    \item{shift}{a number between 0 and 1 decribing the amount to shift points with respects to the guiding lines and axis labels. Useful when \code{add=TRUE}}
    \item{add}{logical indicating whether a new plot should be created. If \code{FALSE}, a new plot will be generated.}
    \item{xlim, ylim, xlab, ylab, main, sub, type,\dots}{parameters to be passed on to \code{plot}}

 }
 \details{
This function uses the data produced by \code{aggregateGeneSet} to plot the means and confidence intervals of the gene sets in \code{QSarray}. By default, the gene sets will be ordered by decreasing mean, and the 95\% confidence intervals of each point (as calculated by \link{calcBayesCI}) will be added. To specify a different order, \code{sort.by} must be set to \code{"none"}, and the order specified by \code{path.index} will be used.

The points in the plot can be optionally color-coded by the significance of the (corrected) p-values. The p-values are adjusted using R's built in \code{\link{p.adjust}} method, which uses the \code{p.adjust.method} parameter to determine the algorithm being used. The colors of the points are based on the breaks specified in \code{p.breaks}. By default, more significant p-values will be plotted in bright red/green. If \code{use.p.colors} is specified and \code{addLegend=TRUE}, a legend describing the p-values will be added to the top left corner of the plot. Alternatively, if you want to specify the colors of the points individually, you can provide a vector of colors to the \code{col} parameter. 

The \code{plotCIs} function can also add a color bar along the bottom of the plot to provide additional information about the pathways. We are currently working on implementing various metrics which can be added automatically using the \code{lowerColorBar} parameter, but in the mean time, the bar can be added manually by providing a vector of colors the same length as \code{path.index} to the \code{lowerColorBar.cols} parameter.
  
 }
 
 \examples{
 
##create example data
  eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
  labels = c(rep("A",10),rep("B",10))
   
  geneSets = list()

##create a number of gene sets with varying levels of differential expression.
  for(i in 0:10){
    genes = ((30*i)+1):(30*(i+1))
    eset[genes,labels=="B"] = eset[genes,labels=="B"] + rnorm(1)
    
    geneSets[[paste("Set",i)]] = genes
  }
   
   
##calculate qusage results
  results = qusage(eset,labels, "B-A", geneSets)
   
##Plot gene set CIs
  plotCIs(results)
   
 }

\name{combinePDFs}
\alias{combinePDFs}
\title{
Combine PDFs from multiple QuSAGE comparisons
}
\description{
This function combines the results of multiple \link{qusage} runs into a single, joint PDF. The resulting PDFs will be the average of the PDFs from each individual QSarray object, weighted by the number of samples in each dataset.
}
\usage{
combinePDFs(QSarrayList, n.points=2^14)
}
\arguments{
  \item{QSarrayList}{A list of QSarray objects, each generated from the same list of geneSets}
  \item{n.points}{integer; the number of points at which to sample the convoluted t-distribution. For best results, this should be about 2-4 times higher than the n.points used in the individual QSarray objects.}
}
\details{
Like \link{aggregateGeneSet}, \code{combinePDFs} uses numerical convolution to calculate the combined PDFs for individual pathways, with each individual PDF weighted by the total number of samples used in the comparison. This method is useful for meta-analysis of multiple datasets, or for a meta comparison where the difference between two QuSAGE pdfs is of interest. 

The results of \code{combinePDFs} can be plotted (on a pathway-by-pathway basis) using the \code{\link{plotCombinedPDF}} function, or by simply calling "\code{plot}" on a QSarray object which contains the QSlist field.
}
\value{
A QSarray object containing a convolution of the original QSarrays. The new QSarray object will contain an additional field, \code{QSlist}, containing the input QSarrayList. 
}

\examples{
##create example data - a set of 500 genes normally distributed across 40 patients
  eset = matrix(rnorm(500*40),500,40, dimnames=list(1:500,1:40))
  labels = rep(c("A","B","C","D"),each=10)
   
##create a number of gene sets with varying levels of differential expression.
  geneSets = list()
  for(i in 0:10){
    genes = ((30*i)+1):(30*(i+1))
    eset[genes,labels=="B"] = eset[genes,labels=="B"] + 2 + rnorm(1)
    eset[genes,labels=="D"] = eset[genes,labels=="D"] + 1 + rnorm(1)
    
    geneSets[[paste("Set",i)]] = genes
  }
   
   
##calculate qusage results
  qsList = lapply(c("B-A","D-C"), function(comparison){
    qusage(eset,labels, comparison, geneSets)
  })
  
##combine the two QSarrays
  qsComb = combinePDFs(qsList)
  
  plot(qsComb, path.index=1)
}

 \name{plotCombinedPDF}
 \alias{plotCombinedPDF}
 \title{Plot combined PDF for an individual pathway}
 \description{
   A function for plotting out the pdfs for an indivdiual pathway in the QScomb object.
 }
 \usage{
plotCombinedPDF(QScomb,
                path.index=1,
                zeroLine=TRUE,
                comb.lwd=3,path.lwd=1,
                comb.col=par("col"),
                path.col=NULL,
                legend=FALSE,legend.labs=NULL,
                add=FALSE,
                xlim=NULL,ylim=NULL,
                xlab=NULL,ylab=NULL,
                main=NULL,
                type="l",
                \dots)
 }
 \arguments{
    \item{QScomb}{\code{QScomb} object}
    \item{path.index}{index describing which pathway to plot. Can either be numeric or a string containing the names of the pathway to plot. Must be of length 1}
    \item{zeroLine}{a logical indicating whether to include a vertical line at 0.}
    \item{comb.lwd}{the lwd for the combined PDF curve.}
    \item{path.lwd}{the lwd for the individual dataset curves. Can be a vector of the same length as QScomb$QSlist specifying the lwd of each individual curve.}
    \item{comb.col}{the color of the combined PDF curve.}
    \item{path.col}{the color of the individual dataset curves. Can be a vector of the same length as QScomb$QSlist specifying the color of each individual curve.}
    \item{legend}{boolean; should a legend be added to the plot? Can also be a character vector specifying the location of the legend (i.e "topleft" vs "topright", etc. See \code{\link[graphics]{legend}} for details)}
    \item{legend.labs}{character vector; the names of each dataset in QScomb$QSlist. If not provided, the function will attempt to pull the labels from QScomb$QSlist, or will use default names if those are undefined.}
    \item{add, xlim, ylim, xlab, ylab, main, type, \dots}{parameters to be passed on to \code{plot}}

 }
 \details{
This function uses the data produced by combinePDFs to plot both the individual dataset PDFs and the combined PDF for a single pathway. By default, \code{plotCombinedPDF} will plot the PDFs for the first pathway in QScomb, but this behavior can be controlled by the \code{path.index} parameter. 
  
 }
 
 \examples{
  ##create 5 example datasets of different sizes
  esets = lapply(1:5, function(i){
    n = 20 + i*5
    eset = matrix(rnorm(500*n),500,n, dimnames=list(1:500,1:n))
    
    labels = c(rep("A",10+5*floor(i/2)),
               rep("B",10+5*ceiling(i/2))
              )
               
    ##genes 1:30 are differentially expressed
    eset[1:30, labels=="B"] = eset[1:30, labels=="B"] + rnorm(30,rnorm(1,0.5,0.5),1)
    
    return(list(eset=eset, labels=labels))
  })
    
  ##gene sets
  geneSets = list(diff.set=1:30, baseline.set=31:60)
  
  ##Run qusage on each dataset
  set.results = lapply(esets, function(dat){
    qusage(dat$eset, dat$labels, "B-A", geneSets)
  })
  
  ##run the combinePDFs function
  combined = combinePDFs(set.results)
  
  ##plot the combined PDF result for "diff.set"
  plotCombinedPDF(combined, path.index="diff.set")
  
 }

\name{qgen}
\alias{qgen}
\title{Run qusage while incoprating generalized least squares and linear mixed model analysis at the gene level to account for repeated measures, continous covariates, and confounder adjusting.
}
\description{
A wrapper function for the three primary steps in the qusage algorithm. The first step replaces the conventional t-test framework, with additional flexibility to incorporate general linear models from the nlme package, specifically the lme and gls function calls. 
}
\usage{
qgen(eset,design,fixed,geneSets,
     contrast.factor,contrast,
     random=NULL,correlation=NULL,design.sampleid=NULL)
}
\arguments{
  \item{eset}{A matrix of log2(expression values), with rows of features and columns of samples.}
  \item{design}{A data frame consisting of sample annotation information such as the various fixed effects that wished to be included in modeling and subject identifiers for the inclusion of random effects.It is recommended that the design file have a column which consists of the column names of \var{eset}. See \var{design.sampleid}}
  \item{fixed}{A one-sided linear formula object describing the fixed-effects part of the model. The formula should always begin with a ~ operator followed by the fixed effect terms, seperated by the + operator.}
  \item{geneSets}{Either a list of pathways to be compared, or a vector of gene names representing a single gene set. See Description for more details.}
  \item{contrast.factor}{A one sided formula indicating the factor in which the user whishes to create a contrast. ~X1 indicates that a differences between the levels of X1 are of interest, where ~X1*X2 indicates that a difference between the level combinations of the the two factors are of interest. Factors included in the formula must be included in \var{fixed}.}
  \item{contrast}{A character string indicating which specific levels of \var{contrast.factor} the user wishes to compare. This is usually of the form "TrtA - TrtB".  For contrast involving level combinations of the form ~X1*X2, the levels are concatonated ie "TrtADay1 - TrtADay0".  The order of concatenation must conform to the order in \var{contrast.factor}. }
  \item{random}{An optional formula to specify random effects and is passed directly to the \link[nlme]{lme} function. For simple repeated measures study designs, the form is usually ~ 1|g where g specifies the donor or subject id's. Defaults to NULL. }
  \item{correlation}{An optional \link[nlme]{corStruct} object to specify within-group correlation structure through the residual covariance matrix and is passed directly to the \link[nlme]{lme} or \link[nlme]{gls} functions. Defaults to NULL.}
  \item{design.sampleid}{A character string indicating a variable name in \var{design} indicating the column names of \var{eset}. If set to NULL, it is assumed that the column ordering in \var{eset} corresponds to the row ordering in \var{design}. Defaults to NULL.}
  
  
}
\details{

This function runs the entire qusage method on the input data, returning a single QSarray object containing the results. Rather than conducting gene level Welch's or paired t-tests, the user can specify more general linear models inherent to \link[nlme]{lme} and \link[nlme]{gls} functions within the \link{nlme} package. This requires the specification of a design file to link the necessary covariates and repeated measures information. One consideration when running more complex linear models is that complexity combined with poorly behaved data can sometimes yield convergence issues during the optimization step.  We encourage users to run their models on individual genes through gls and lme directly to ensure their models are paramaterized correctly and as expected.  Additional filtering of probes may need to be conducted for genes that have little variation as this can cause convergence issues.

Gene sets are commonly obtained from online databases such as Broad's Molecular Signatures Database. Gene set lists can be obtained from these sites in the form of .gmt files, which can be read into R using the \code{\link{read.gmt}} function. Once the data has been read into R, the information can be passed into the qusage function as either a vector describing a single gene set, or a list of vectors representing a group of gene sets. Each pathway must be a character vector with entries matching the row names of \var{eset}. If a pathway does not contain any values matching the rownames of \var{eset}, a warning will be printed, and the function will return NAs for the values of that pathway.


}
\value{
 A \link[=QSarray-class]{QSarray} object.
}

\examples{
##Creating a design file of 20 patients (10 in conditionA/10 in conditionB 
# with 5 timepoints)
# In addition, we also create a dummy continous covariate that is partially confounded
# with condition. Condition B will have a higher mean for the covariate than condition A.

des<-data.frame(SampleID=paste("Sample",1:100,sep=""),
                Condition=rep(c("A","B"),each=50),
                Donor=rep(letters[1:20],each=5),
                Time=rep(paste("D",0:4,sep=""),20),
                stringsAsFactors=TRUE)


##Create example data - a set of 500 genes normally dstributed across 20 patients 
##with 5 timepoints
eset = matrix(rnorm(500*100),500,100, dimnames=list(1:500,1:100))
colnames(eset)= paste("Sample",1:100,sep="")

##create a number of gene sets with varying levels of differential expression between 
##conditions and between timepoints
geneSets = list()
for(i in 0:10){
  genes = ((30*i)+1):(30*(i+1))
  eset[genes,des$Condition=="B"] = eset[genes,des$Condition=="B"] + rnorm(1)
  eset[genes,des$Time=="D1"]=eset[genes,des$Time=="D1"]+rnorm(1)
  
  geneSets[[paste("Set",i)]] = genes
}

##Adding additional subject specific variability to generate repeated measures correlations
for(i in 1:500){
  eset[i,]<-eset[i,]+rep(rnorm(20,0,4),each=5)
}



##Running a linear mixed model to test for D1 vs D0 for Condition B, with a subject
## specific random effect

qs.result<-qgen(eset,des,geneSets=geneSets,
                fixed= ~Condition+Time+Time*Condition,random=~1|Donor,
                contrast.factor=~Condition*Time,contrast="BD1-BD0",
                design.sampleid="SampleID")

plot(qs.result)
}

 \name{aggregateGeneSet}
 \alias{aggregateGeneSet}
 \title{Calculate Pathway Activation}
 \description{
   Combine individual gene differential expresseion for each pathway
 }
 \usage{
aggregateGeneSet(geneResults, geneSets, n.points=2^12, silent=TRUE)
 }
 \arguments{
    \item{geneResults}{A QSarray object, as generated by makeComparison}
    \item{geneSets}{A list of pathways to be compared. See description for more details.}
    \item{n.points}{The number of points at which to sample the convoluted t-distribution. See Details for more information on appropriate values for this parameter.}
    \item{silent}{If false, print a "." after every fifth pathway, as a way to track progress.}
 }
 \details{
  This function convolutes individual gene t-distributions into a single PDF for each gene set.
  
  The \var{geneSets} parameter can either be provided as a vector describing a single gene set, or a list of vectors representing a group of gene sets (such as the ones available from Broad's Molecular Signatures Database). Each pathway must be a character vector with entries matching the row names of \var{eset}. If a pathway does not contain any values matching the rownames of \var{eset}, a warning will be printed, and the function will return NAs for the values of that pathway.
  
  By default the parameter \var{n.points} is set to 2^12, or 4096 points, which will give very accurate p-values in most cases. Sampling at more points will increase the accuracy of the resulting p-values, but will also linearly increase the amount of time needed to calculate the result. With larger sample sizes, as few as 1/4 this number of points can be used without seriously affecting the accuracy of the resulting p-values, however when there are a small number of samples (i.e. less than 8 samples total), the t-distribution must be sampled over a much wider range, and the number of points needed for sampling should be increased accordingly. It is recommended that when running \code{aggregateGeneSet} with less than 8 samples the number of points be increased to at least 2^15 or 2^16. It may also be useful to test higher values of this parameter, as it can often result in a much more significant p-value with small sample sizes.
  
  The PDF for each individual gene set is generated by using numerical convolution applied to the individual gene PDFs. Briefly, a Fast Fourier Transform (FFT) is calculated for each individual gene PDF to arrive at a k-component vector. The product of each component across all of the genes is then taken to arrive at a new k-component vector for the gene set. The real part of the resulting product is then transformed back to a PDF using a reverse FFT, and assured to be normalized and centered around zero. The mean of the combined PDF is simply the mean fold change of the individual genes. The range for sampling is determined by the lowest degrees of freedom of the individual genes, such that at most 10^-8 of the cumulative distribution at the tails are excluded (i.e., assumed to be 0). For example, when nu = 3, the range is (-480,480), and when nu = 120, the range is (-6,6). 

  Technically, the output of this step is the PDF of the \emph{sum} of differences in expressions over all genes in the gene set under the assumption that the genes are independent. In order to estimate the \emph{mean} differential expression PDF, this distribution is scaled by a factor of 1/N, where N is the number of genes in the gene set. The resulting PDFs of the input gene sets are stored as a matrix in \var{path.PDF} slot of the returned QSarray object. However, the x-coordinates for these PDFs are not stored in the QSarray object, and must be calculated using the \link{getXcoords} function.
  
 }    
 \value{
   A \link[=QSarray-class]{QSarray} object.
 }
 \examples{
  ##create example data
  eset = matrix(rnorm(500*20),500,20, dimnames=list(1:500,1:20))
  labels = c(rep("A",10),rep("B",10))
   
  ##first 30 genes are differentially expressed
  eset[1:30, labels=="B"] = eset[1:30, labels=="B"] + 1
   
  ##compare the two groups
  geneResults = makeComparison(eset, labels, "B-A")
  
  ##aggregate data for gene sets
  geneSets = list(set1=1:30, set2=31:60)
  set.results = aggregateGeneSet(geneResults, geneSets)
  
 }
